# generated by datamodel-codegen:
#   filename:  https://development-api.integrationos.com/v1/public/openapi
#   timestamp: 2024-10-30T13:14:55+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from pathlib import Path
from typing import Any, Dict, List, Optional

from pydantic import AnyUrl, BaseModel, EmailStr, Field, SecretStr


class GeoCoordinates(BaseModel):
    commonModel: Optional[str] = None
    latitude: Optional[float] = None
    longitude: Optional[float] = None
    altitude: Optional[float] = None
    accuracy: Optional[float] = None
    altitudeAccuracy: Optional[float] = None
    heading: Optional[float] = None
    speed: Optional[float] = None
    timestamp: Optional[datetime] = None


class CommunicationMethod(Enum):
    email = 'email'
    phone = 'phone'
    text = 'text'
    mail = 'mail'
    in_person = 'in-person'
    sms = 'sms'
    push_notification = 'push-notification'
    instant_message = 'instant-message'
    social_media = 'social-media'
    video_call = 'video-call'
    other = 'other'


class ContactAddressType(Enum):
    home = 'home'
    work = 'work'
    other = 'other'
    personal = 'personal'
    business = 'business'
    billing = 'billing'
    shipping = 'shipping'
    temporary = 'temporary'


class Currency(Enum):
    AED = 'AED'
    AFN = 'AFN'
    ALL = 'ALL'
    AMD = 'AMD'
    ANG = 'ANG'
    AOA = 'AOA'
    ARS = 'ARS'
    AUD = 'AUD'
    AWG = 'AWG'
    AZN = 'AZN'
    BAM = 'BAM'
    BBD = 'BBD'
    BDT = 'BDT'
    BGN = 'BGN'
    BHD = 'BHD'
    BIF = 'BIF'
    BMD = 'BMD'
    BND = 'BND'
    BOB = 'BOB'
    BRL = 'BRL'
    BSD = 'BSD'
    BTN = 'BTN'
    BWP = 'BWP'
    BYN = 'BYN'
    BZD = 'BZD'
    CAD = 'CAD'
    CDF = 'CDF'
    CHF = 'CHF'
    CLP = 'CLP'
    CNY = 'CNY'
    COP = 'COP'
    CRC = 'CRC'
    CUC = 'CUC'
    CUP = 'CUP'
    CVE = 'CVE'
    CZK = 'CZK'
    DJF = 'DJF'
    DKK = 'DKK'
    DOP = 'DOP'
    DZD = 'DZD'
    EGP = 'EGP'
    ERN = 'ERN'
    ETB = 'ETB'
    EUR = 'EUR'
    FJD = 'FJD'
    FKP = 'FKP'
    FOK = 'FOK'
    GBP = 'GBP'
    GEL = 'GEL'
    GGP = 'GGP'
    GHS = 'GHS'
    GIP = 'GIP'
    GMD = 'GMD'
    GNF = 'GNF'
    GTQ = 'GTQ'
    GYD = 'GYD'
    HKD = 'HKD'
    HNL = 'HNL'
    HRK = 'HRK'
    HTG = 'HTG'
    HUF = 'HUF'
    IDR = 'IDR'
    ILS = 'ILS'
    IMP = 'IMP'
    INR = 'INR'
    IQD = 'IQD'
    IRR = 'IRR'
    ISK = 'ISK'
    JEP = 'JEP'
    JMD = 'JMD'
    JOD = 'JOD'
    JPY = 'JPY'
    KES = 'KES'
    KGS = 'KGS'
    KHR = 'KHR'
    KID = 'KID'
    KMF = 'KMF'
    KPW = 'KPW'
    KRW = 'KRW'
    KWD = 'KWD'
    KYD = 'KYD'
    KZT = 'KZT'
    LAK = 'LAK'
    LBP = 'LBP'
    LKR = 'LKR'
    LRD = 'LRD'
    LSL = 'LSL'
    LYD = 'LYD'
    MAD = 'MAD'
    MDL = 'MDL'
    MGA = 'MGA'
    MKD = 'MKD'
    MMK = 'MMK'
    MNT = 'MNT'
    MOP = 'MOP'
    MRU = 'MRU'
    MUR = 'MUR'
    MVR = 'MVR'
    MWK = 'MWK'
    MXN = 'MXN'
    MYR = 'MYR'
    MZN = 'MZN'
    NAD = 'NAD'
    NGN = 'NGN'
    NIO = 'NIO'
    NOK = 'NOK'
    NPR = 'NPR'
    NZD = 'NZD'
    OMR = 'OMR'
    PAB = 'PAB'
    PEN = 'PEN'
    PGK = 'PGK'
    PHP = 'PHP'
    PKR = 'PKR'
    PLN = 'PLN'
    PYG = 'PYG'
    QAR = 'QAR'
    RON = 'RON'
    RSD = 'RSD'
    RUB = 'RUB'
    RWF = 'RWF'
    SAR = 'SAR'
    SBD = 'SBD'
    SCR = 'SCR'
    SDG = 'SDG'
    SEK = 'SEK'
    SGD = 'SGD'
    SHP = 'SHP'
    SLL = 'SLL'
    SOS = 'SOS'
    SRD = 'SRD'
    SSP = 'SSP'
    STN = 'STN'
    SYP = 'SYP'
    SZL = 'SZL'
    THB = 'THB'
    TJS = 'TJS'
    TMT = 'TMT'
    TND = 'TND'
    TOP = 'TOP'
    TRY = 'TRY'
    TTD = 'TTD'
    TVD = 'TVD'
    TWD = 'TWD'
    TZS = 'TZS'
    UAH = 'UAH'
    UGX = 'UGX'
    USD = 'USD'
    UYU = 'UYU'
    UZS = 'UZS'
    VES = 'VES'
    VND = 'VND'
    VUV = 'VUV'
    WST = 'WST'
    XAF = 'XAF'
    XCD = 'XCD'
    XDR = 'XDR'
    XOF = 'XOF'
    XPF = 'XPF'
    YER = 'YER'
    ZAR = 'ZAR'
    ZMW = 'ZMW'
    ZWL = 'ZWL'


class CustomerStatus(Enum):
    active = 'active'
    inactive = 'inactive'
    archived = 'archived'
    pending = 'pending'
    suspended = 'suspended'


class CustomerType(Enum):
    retail = 'retail'
    wholesale = 'wholesale'
    online = 'online'
    b2b = 'b2b'
    b2c = 'b2c'
    corporate = 'corporate'


class DataType(Enum):
    string = 'string'
    number = 'number'
    boolean = 'boolean'
    date = 'date'
    json = 'json'
    array = 'array'
    object = 'object'
    null = 'null'
    undefined = 'undefined'
    binary = 'binary'
    timestamp = 'timestamp'
    custom = 'custom'


class DeviceUsageType(Enum):
    personal = 'personal'
    business = 'business'
    educational = 'educational'
    industrial = 'industrial'
    healthcare = 'healthcare'
    home = 'home'
    other = 'other'


class EmailCategoryType(Enum):
    personal = 'personal'
    business = 'business'
    educational = 'educational'
    governmental = 'governmental'
    promotional = 'promotional'
    transactional = 'transactional'
    spam = 'spam'
    other = 'other'


class EntityCategory(Enum):
    user = 'user'
    project = 'project'
    message = 'message'
    document = 'document'
    link = 'link'
    task = 'task'
    event = 'event'
    person = 'person'
    owner = 'owner'
    other = 'other'


class SocialPlatform(Enum):
    facebook = 'facebook'
    x = 'x'
    twitter = 'twitter'
    linkedin = 'linkedin'
    instagram = 'instagram'
    tiktok = 'tiktok'
    pinterest = 'pinterest'
    youtube = 'youtube'
    snapchat = 'snapchat'
    reddit = 'reddit'
    tumblr = 'tumblr'
    skype = 'skype'
    other_social_platform = 'other-social-platform'


class Preferences(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    language: Optional[str] = None
    currency: Optional[Currency] = None
    timeZone: Optional[str] = None
    communications: Optional[CommunicationMethod] = None


class IdentityProvider(Enum):
    google = 'google'
    facebook = 'facebook'
    twitter = 'twitter'
    linkedin = 'linkedin'
    microsoft = 'microsoft'
    apple = 'apple'
    github = 'github'
    yahoo = 'yahoo'
    amazon = 'amazon'
    paypal = 'paypal'
    instagram = 'instagram'
    tiktok = 'tiktok'
    pinterest = 'pinterest'
    snapchat = 'snapchat'
    reddit = 'reddit'
    tumblr = 'tumblr'
    foursquare = 'foursquare'
    flickr = 'flickr'
    vimeo = 'vimeo'
    dribbble = 'dribbble'
    behance = 'behance'
    slack = 'slack'
    discord = 'discord'
    whatsapp = 'whatsapp'
    telegram = 'telegram'
    signal = 'signal'
    line = 'line'
    wechat = 'wechat'
    qq = 'qq'
    other = 'other'


class ImageMimeType(Enum):
    image_jpeg = 'image/jpeg'
    image_png = 'image/png'
    image_gif = 'image/gif'
    image_svg_xml = 'image/svg+xml'
    image_webp = 'image/webp'
    image_bmp = 'image/bmp'
    image_tiff = 'image/tiff'
    image_heic = 'image/heic'


class ImageType(Enum):
    base64 = 'base64'


class PaymentMethod(Enum):
    bank_transfer = 'bank-transfer'
    cash = 'cash'
    cash_on_delivery = 'cash-on-delivery'
    check = 'check'
    credit_card = 'credit-card'
    cryptocurrency = 'cryptocurrency'
    debit_card = 'debit-card'
    mobile_payment = 'mobile-payment'
    mobile_wallet = 'mobile-wallet'
    paypal = 'paypal'
    other = 'other'


class UserStatus(Enum):
    pending = 'pending'
    verified = 'verified'
    suspended = 'suspended'
    inactive = 'inactive'
    active = 'active'
    banned = 'banned'
    deleted = 'deleted'
    archived = 'archived'
    wait_listed = 'wait-listed'


class Gender(Enum):
    Male = 'Male'
    Female = 'Female'
    Other = 'Other'
    Prefer_not_to_say = 'Prefer not to say'


class Role(Enum):
    User = 'User'
    Admin = 'Admin'
    Moderator = 'Moderator'


class PerformanceMetrics(BaseModel):
    commonModel: Optional[str] = None
    impressions: Optional[float] = None
    clicks: Optional[float] = None
    conversions: Optional[float] = None
    spend: Optional[float] = None
    returnOnInvestment: Optional[float] = None
    costPerClick: Optional[float] = None
    costPerConversion: Optional[float] = None
    conversionRate: Optional[float] = None


class UserRole(Enum):
    User = 'User'
    Admin = 'Admin'
    Moderator = 'Moderator'


class AccessControlModel(Enum):
    rbac = 'rbac'
    abac = 'abac'
    dac = 'dac'
    mac = 'mac'
    custom = 'custom'
    none = 'none'


class CampaignStatus(Enum):
    planned = 'planned'
    active = 'active'
    paused = 'paused'
    completed = 'completed'
    cancelled = 'cancelled'
    draft = 'draft'
    scheduled = 'scheduled'
    archived = 'archived'


class CampaignType(Enum):
    email = 'email'
    social_media = 'social-media'
    search_engine = 'search-engine'
    display = 'display'
    other = 'other'


class ContentVisibility(Enum):
    private = 'private'
    public = 'public'
    shared = 'shared'
    internal = 'internal'
    protected = 'protected'


class ParticipantType(Enum):
    user = 'user'
    group = 'group'
    team = 'team'
    organization = 'organization'
    external_participant = 'external-participant'


class PriorityLevel(Enum):
    low = 'low'
    medium = 'medium'
    high = 'high'
    urgent = 'urgent'
    elevated = 'elevated'


class UniversalIdentifierType(Enum):
    string = 'string'
    number = 'number'
    email = 'email'
    uuid = 'uuid'
    url = 'url'


class AppliesTo(Enum):
    all_items = 'all-items'
    specific_items = 'specific-items'
    specific_categories = 'specific-categories'


class CustomerEligibility(Enum):
    all = 'all'
    specific_customers = 'specific-customers'
    specific_customer_groups = 'specific-customer-groups'


class MinimumRequirements(Enum):
    none = 'none'
    minimum_purchase_amount = 'minimum-purchase-amount'
    minimum_quantity_of_items = 'minimum-quantity-of-items'


class Status(Enum):
    active = 'active'
    expired = 'expired'
    scheduled = 'scheduled'


class ChannelAvailability(Enum):
    online = 'online'
    in_app = 'in-app'
    in_store = 'in-store'
    all_channels = 'all-channels'


class Modifiers(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    customerNote: Optional[str] = None
    linePrice: Optional[float] = None
    originalPrice: Optional[float] = None
    quantity: Optional[float] = None
    currency: Optional[Currency] = None
    groupId: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deleted: Optional[bool] = None
    active: Optional[bool] = None
    modifyToken: Optional[str] = None


class UsageLimitExpirations(BaseModel):
    commonModel: Optional[str] = None
    limit: Optional[float] = None
    expirationDate: Optional[datetime] = None


class DiscountType(Enum):
    percentage = 'percentage'
    fixed_amount = 'fixed-amount'
    buy_one_get_one = 'buy-one-get-one'
    tiered_discount = 'tiered-discount'
    conditional_discount = 'conditional-discount'
    variable_percentage = 'variable-percentage'
    variable_amount = 'variable-amount'
    unknown_discount = 'unknown-discount'


class OrderStatus(Enum):
    pending = 'pending'
    processing = 'processing'
    on_hold = 'on-hold'
    awaiting_payment = 'awaiting-payment'
    awaiting_pickup = 'awaiting-pickup'
    awaiting_shipment = 'awaiting-shipment'
    partially_fulfilled = 'partially-fulfilled'
    shipped = 'shipped'
    delivered = 'delivered'
    cancelled = 'cancelled'
    returned = 'returned'
    refunded = 'refunded'
    failed = 'failed'
    disputed = 'disputed'
    completed = 'completed'
    abandoned = 'abandoned'
    confirmed = 'confirmed'
    draft = 'draft'


class PaymentStatus(Enum):
    draft = 'draft'
    partial = 'partial'
    submitted = 'submitted'
    authorized = 'authorized'
    error = 'error'
    adjusted = 'adjusted'
    pending = 'pending'
    processing = 'processing'
    succeeded = 'succeeded'
    failed = 'failed'
    cancelled = 'cancelled'
    refunded = 'refunded'
    partially_refunded = 'partially-refunded'
    disputed = 'disputed'
    overdue = 'overdue'
    paid = 'paid'
    voided = 'voided'
    deleted = 'deleted'


class TaxType(Enum):
    inclusive = 'inclusive'
    additive = 'additive'
    variable = 'variable'


class TaskStatus(Enum):
    todo = 'todo'
    in_progress = 'in-progress'
    done = 'done'
    blocked = 'blocked'
    on_hold = 'on-hold'
    cancelled = 'cancelled'


class LeadSource(BaseModel):
    commonModel: Optional[str] = None
    sourceId: Optional[str] = None
    sourceName: Optional[str] = None
    details: Optional[str] = None


class LeadLifecycleStatus(Enum):
    new = 'new'
    open = 'open'
    in_process = 'in-process'
    converted = 'converted'
    unqualified = 'unqualified'
    attempted_to_contact = 'attempted-to-contact'
    connected = 'connected'
    bad_timing = 'bad-timing'
    revisited = 'revisited'
    lost = 'lost'


class Dimensions(BaseModel):
    commonModel: Optional[str] = None
    height: Optional[float] = None
    length: Optional[float] = None
    width: Optional[float] = None


class ProductOptions(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    productId: Optional[float] = None
    name: Optional[str] = None
    values: Optional[List[str]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None


class ItemAvailabilityStatus(Enum):
    active = 'active'
    inactive = 'inactive'
    out_of_stock = 'out-of-stock'
    discontinued = 'discontinued'


class ItemCondition(Enum):
    new = 'new'
    refurbished = 'refurbished'
    used = 'used'
    like_new = 'like-new'
    open_box = 'open-box'
    damaged = 'damaged'


class ProductAvailabilityStatus(Enum):
    in_stock = 'in-stock'
    out_of_stock = 'out-of-stock'
    back_order = 'back-order'
    pre_order = 'pre-order'
    discontinued = 'discontinued'


class ReviewApprovalStatus(Enum):
    pending = 'pending'
    in_review = 'in-review'
    approved = 'approved'
    rejected = 'rejected'
    revised = 'revised'


class KeyValues(BaseModel):
    commonModel: Optional[str] = None
    key: Optional[str] = None
    value: Optional[str] = None


class Prices(BaseModel):
    commonModel: Optional[str] = None
    amount: Optional[float] = None
    currency: Optional[Currency] = None
    type: Optional[str] = None


class Localizations(BaseModel):
    commonModel: Optional[str] = None
    locale: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    metaTitle: Optional[str] = None
    metaDescription: Optional[str] = None


class EntityLifecycleStatus(Enum):
    active = 'active'
    archived = 'archived'
    preorder = 'preorder'
    draft = 'draft'
    deleted = 'deleted'
    inactive = 'inactive'
    scheduled = 'scheduled'


class InventoryStorageType(Enum):
    warehouse = 'warehouse'
    retail_store = 'retail-store'
    distribution_center = 'distribution-center'
    drop_shipper = 'drop-shipper'
    online_marketplace = 'online-marketplace'
    consignment = 'consignment'
    other = 'other'


class ItemEntityStatus(Enum):
    active = 'active'
    inactive = 'inactive'
    archived = 'archived'
    pending = 'pending'
    suspended = 'suspended'
    deleted = 'deleted'
    completed = 'completed'


class SkuValidation(Enum):
    global_unique = 'global_unique'
    local_unique = 'local_unique'
    none = 'none'


class Categories(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    image: Optional[str] = None
    parentId: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    tags: Optional[List[str]] = None
    modifyToken: Optional[str] = None


class IssueLifecycleStatus(Enum):
    open = 'open'
    pending = 'pending'
    in_progress = 'in-progress'
    on_hold = 'on-hold'
    waiting = 'waiting'
    resolved = 'resolved'
    cancelled = 'cancelled'
    closed = 'closed'


class SupportQueryType(Enum):
    question = 'question'
    incident = 'incident'
    problem = 'problem'
    task = 'task'
    bug = 'bug'
    feature_request = 'feature-request'
    feedback = 'feedback'


class SupportTicketPriority(Enum):
    low = 'low'
    medium = 'medium'
    high = 'high'
    urgent = 'urgent'
    immediate = 'immediate'


class EmploymentUnits(BaseModel):
    commonModel: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None


class EmploymentType(Enum):
    full_time = 'full-time'
    part_time = 'part-time'
    contract = 'contract'
    temporary = 'temporary'
    volunteer = 'volunteer'
    internship = 'internship'
    seasonal = 'seasonal'
    freelance = 'freelance'
    permanent = 'permanent'


class TimeCycle(Enum):
    secondly = 'secondly'
    minutely = 'minutely'
    hourly = 'hourly'
    daily = 'daily'
    weekly = 'weekly'
    biweekly = 'biweekly'
    semi_monthly = 'semi-monthly'
    monthly = 'monthly'
    quarterly = 'quarterly'
    semi_annually = 'semi-annually'
    annually = 'annually'
    biennially = 'biennially'
    triennially = 'triennially'
    ad_hoc = 'ad-hoc'
    custom = 'custom'


class IncomeTaxExpenseDetails(BaseModel):
    commonModel: Optional[str] = None
    currentIncomeTax: Optional[float] = None
    deferredIncomeTax: Optional[float] = None
    taxAllowanceCredit: Optional[float] = None


class ShareholderEquityDetails(BaseModel):
    commonModel: Optional[str] = None
    commonStock: Optional[float] = None
    preferredStock: Optional[float] = None
    retainedEarnings: Optional[float] = None
    accumulatedOtherComprehensiveIncome: Optional[float] = None
    treasuryStock: Optional[float] = None


class RevenueDetails(BaseModel):
    commonModel: Optional[str] = None
    salesRevenue: Optional[float] = None
    serviceRevenue: Optional[float] = None
    otherRevenue: Optional[float] = None


class OperatingExpensesDetails(BaseModel):
    commonModel: Optional[str] = None
    researchAndDevelopmentExpenses: Optional[float] = None
    salesGeneralAndAdministrativeExpenses: Optional[float] = None
    otherOperatingExpenses: Optional[float] = None


class IncomeStatements(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    period: Optional[str] = None
    currency: Optional[Currency] = None
    exchangeRate: Optional[float] = None
    revenue: Optional[RevenueDetails] = None
    costOfGoodsSold: Optional[float] = None
    grossProfit: Optional[float] = None
    operatingExpenses: Optional[OperatingExpensesDetails] = None
    operatingIncome: Optional[float] = None
    interestExpense: Optional[float] = None
    depreciationAndAmortization: Optional[float] = None
    ebitda: Optional[float] = None
    incomeBeforeTax: Optional[float] = None
    incomeTaxExpense: Optional[IncomeTaxExpenseDetails] = None
    netIncome: Optional[float] = None
    shareholderEquity: Optional[ShareholderEquityDetails] = None
    profitMargins: Optional[float] = None
    accountSummary: Optional[List[KeyValues]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class AuditOpinionType(Enum):
    unqualified = 'unqualified'
    qualified = 'qualified'
    disclaimer = 'disclaimer'
    adverse = 'adverse'


class FinancialTrackingCategories(Enum):
    none = 'none'
    project = 'project'
    department = 'department'
    location = 'location'
    class_ = 'class'
    cost_center = 'cost-center'
    division = 'division'
    customer = 'customer'
    vendor = 'vendor'
    employee = 'employee'
    product = 'product'
    service = 'service'
    other = 'other'


class JournalEntryStatus(Enum):
    draft = 'draft'
    pending = 'pending'
    posted = 'posted'
    voided = 'voided'
    error = 'error'
    corrected = 'corrected'


class InvoicePayments(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    amount: Optional[float] = None
    date: Optional[datetime] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class InvoiceAdjustmentType(Enum):
    discount = 'discount'
    tax = 'tax'
    shipping = 'shipping'
    tip = 'tip'
    other = 'other'


class PaymentTerm(Enum):
    net = 'net'
    cash_in_advance = 'cash-in-advance'
    cash_with_order = 'cash-with-order'
    cash_before_shipment = 'cash-before-shipment'
    deferred_payment = 'deferred-payment'
    prepayment = 'prepayment'
    installment = 'installment'
    net_30 = 'net-30'
    net_60 = 'net-60'
    net_90 = 'net-90'
    due_on_receipt = 'due-on-receipt'
    due_end_of_month = 'due-end-of-month'
    cash_on_delivery = 'cash-on-delivery'
    prepaid = 'prepaid'
    upon_completion = 'upon-completion'
    custom = 'custom'


class Educations(BaseModel):
    commonModel: Optional[str] = None
    institution: Optional[str] = None
    degree: Optional[str] = None
    fieldOfStudy: Optional[str] = None
    startDate: Optional[datetime] = None
    endDate: Optional[datetime] = None
    gpa: Optional[float] = None


class WorkExperiences(BaseModel):
    commonModel: Optional[str] = None
    company: Optional[str] = None
    position: Optional[str] = None
    startDate: Optional[datetime] = None
    endDate: Optional[datetime] = None
    description: Optional[str] = None


class References(BaseModel):
    commonModel: Optional[str] = None
    name: Optional[str] = None
    relationship: Optional[str] = None
    company: Optional[str] = None
    position: Optional[str] = None
    email: Optional[EmailStr] = None
    phoneNumber: Optional[str] = None


class EmploymentAndCandidateStatus(Enum):
    active = 'active'
    inactive = 'inactive'
    on_leave = 'on-leave'
    terminated = 'terminated'
    new = 'new'
    in_review = 'in-review'
    interviewing = 'interviewing'
    offer_extended = 'offer-extended'
    hired = 'hired'
    not_selected = 'not-selected'
    other = 'other'


class TransactionStatus(Enum):
    initiated = 'initiated'
    pending = 'pending'
    in_progress = 'in-progress'
    succeeded = 'succeeded'
    failed = 'failed'
    cancelled = 'cancelled'
    error = 'error'


class Refunds(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    paymentId: Optional[str] = None
    amount: Optional[float] = None
    currency: Optional[Currency] = None
    reason: Optional[str] = None
    status: Optional[TransactionStatus] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class BillingStatus(Enum):
    draft = 'draft'
    submitted = 'submitted'
    authorised = 'authorised'
    paid = 'paid'
    unpaid = 'unpaid'
    pending = 'pending'
    overdue = 'overdue'
    voided = 'voided'
    partially_paid = 'partially-paid'
    deleted = 'deleted'


class PurchaseOrderLineItems(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    productId: Optional[str] = None
    quantity: Optional[float] = None
    unitPrice: Optional[float] = None
    totalPrice: Optional[float] = None
    description: Optional[str] = None
    deliveryDate: Optional[datetime] = None
    SKU: Optional[str] = None
    unitOfMeasure: Optional[str] = None
    discount: Optional[float] = None


class AvcStatus(Enum):
    accepted = 'accepted'
    rejected = 'rejected'
    not_checked = 'not-checked'


class CardType(Enum):
    credit = 'credit'
    debit = 'debit'
    unknown_card = 'unknown-card'


class CvvStatus(Enum):
    accepted = 'accepted'
    rejected = 'rejected'
    not_checked = 'not-checked'


class EntryMethod(Enum):
    keyed = 'keyed'
    swiped = 'swiped'
    emv = 'emv'
    on_file = 'on-file'
    contactless = 'contactless'


class PrepaidType(Enum):
    prepaid = 'prepaid'
    not_prepaid = 'not-prepaid'
    unknown_prepaid = 'unknown-prepaid'


class ExpenseCategories(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None


class ExpenseApprovalStatus(Enum):
    new = 'new'
    pending = 'pending'
    approved = 'approved'
    denied = 'denied'
    reimbursed = 'reimbursed'
    reviewing = 'reviewing'
    cancelled = 'cancelled'
    processed = 'processed'


class CurrencyDetails(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    currency: Optional[Currency] = None
    value: Optional[float] = None


class Evidence(BaseModel):
    commonModel: Optional[str] = None
    accessActivityLog: Optional[str] = None
    billingAddress: Optional[str] = None
    cancellationPolicy: Optional[str] = None
    cancellationPolicyDisclosure: Optional[str] = None
    cancellationRebuttal: Optional[str] = None
    customerCommunication: Optional[str] = None
    customerEmailAddress: Optional[str] = None
    customerName: Optional[str] = None
    customerPurchaseIp: Optional[str] = None
    customerSignature: Optional[str] = None
    duplicateChargeDocumentation: Optional[str] = None
    duplicateChargeExplanation: Optional[str] = None
    duplicateChargeId: Optional[str] = None
    productDescription: Optional[str] = None
    receipt: Optional[str] = None
    refundPolicy: Optional[str] = None
    refundPolicyDisclosure: Optional[str] = None
    refundRefusalExplanation: Optional[str] = None
    serviceDate: Optional[datetime] = None
    serviceDocumentation: Optional[str] = None
    shippingAddress: Optional[str] = None
    shippingCarrier: Optional[str] = None
    shippingDate: Optional[datetime] = None
    shippingDocumentation: Optional[str] = None
    shippingTrackingNumber: Optional[str] = None
    uncategorizedFile: Optional[str] = None
    uncategorizedText: Optional[str] = None


class FinancialDisputeStatus(Enum):
    needs_response = 'needs-response'
    under_review = 'under-review'
    charge_refunded = 'charge-refunded'
    won = 'won'
    lost = 'lost'
    closed = 'closed'
    escalated = 'escalated'
    awaiting_evidence = 'awaiting-evidence'


class FinancialTransactionStatus(Enum):
    pending = 'pending'
    cleared = 'cleared'
    cancelled = 'cancelled'
    failed = 'failed'
    refunded = 'refunded'
    disputed = 'disputed'
    authorized = 'authorized'
    settlement_in_progress = 'settlement-in-progress'


class FinancialTransactionType(Enum):
    deposit = 'deposit'
    withdrawal = 'withdrawal'
    transfer = 'transfer'
    fee = 'fee'
    refund = 'refund'
    adjustment = 'adjustment'
    interest = 'interest'
    dividend = 'dividend'
    payment = 'payment'
    charge = 'charge'
    sale = 'sale'
    chargeback = 'chargeback'
    receive = 'receive'
    receive_overpayment = 'receive-overpayment'
    receive_prepayment = 'receive-prepayment'
    spend = 'spend'
    spend_overpayment = 'spend-overpayment'
    spend_prepayment = 'spend-prepayment'
    other = 'other'


class TransactionType(Enum):
    payment = 'payment'
    transfer = 'transfer'
    withdrawal = 'withdrawal'
    deposit = 'deposit'
    fee = 'fee'
    refund = 'refund'
    adjustment = 'adjustment'
    charge = 'charge'


class TransactionMethod(Enum):
    online = 'online'
    atm = 'atm'
    bank_branch = 'bank-branch'
    mail = 'mail'
    mobile = 'mobile'
    telephone = 'telephone'


class FinancialAccountStatus(Enum):
    active = 'active'
    closed = 'closed'
    frozen = 'frozen'
    suspended = 'suspended'
    inactive = 'inactive'
    under_review = 'under-review'
    delinquent = 'delinquent'


class AccountType(Enum):
    accounts_receivable = 'accounts-receivable'
    asset__accumulated_amortization_of_other_assets = (
        'asset::accumulated-amortization-of-other-assets'
    )
    asset__accumulated_amortization = 'asset::accumulated-amortization'
    asset__accumulated_depletion = 'asset::accumulated-depletion'
    asset__accumulated_depreciation = 'asset::accumulated-depreciation'
    asset__allowance_for_bad_debts = 'asset::allowance-for-bad-debts'
    asset__assets_available_for_sale = 'asset::assets-available-for-sale'
    asset__assets_held_for_sale = 'asset::assets-held-for-sale'
    asset__assets_in_course_of_construction = 'asset::assets-in-course-of-construction'
    asset__available_for_sale_financial_assets = (
        'asset::available-for-sale-financial-assets'
    )
    asset__bal_with_govt_authorities = 'asset::bal-with-govt-authorities'
    asset__bank = 'asset::bank'
    asset__buildings = 'asset::buildings'
    asset__called_up_share_capital_not_paid = 'asset::called-up-share-capital-not-paid'
    asset__capital_wip = 'asset::capital-wip'
    asset__cash_and_cash_equivalents = 'asset::cash-and-cash-equivalents'
    asset__cash_on_hand = 'asset::cash-on-hand'
    asset__checking = 'asset::checking'
    asset__cumulative_depreciation_on_intangible_assets = (
        'asset::cumulative-depreciation-on-intangible-assets'
    )
    asset__deferred_tax = 'asset::deferred-tax'
    asset__depletable_assets = 'asset::depletable-assets'
    asset__development_costs = 'asset::development-costs'
    asset__employee_cash_advances = 'asset::employee-cash-advances'
    asset__expenditure_authorisations_and_letters_of_credit = (
        'asset::expenditure-authorisations-and-letters-of-credit'
    )
    asset__fixed_asset_computers = 'asset::fixed-asset-computers'
    asset__fixed_asset_copiers = 'asset::fixed-asset-copiers'
    asset__fixed_asset_furniture = 'asset::fixed-asset-furniture'
    asset__fixed_asset_other_tools_equipment = (
        'asset::fixed-asset-other-tools-equipment'
    )
    asset__fixed_asset_phone = 'asset::fixed-asset-phone'
    asset__fixed_asset_photo_video = 'asset::fixed-asset-photo-video'
    asset__fixed_asset_software = 'asset::fixed-asset-software'
    asset__fixed_asset = 'asset::fixed-asset'
    asset__furniture_and_fixtures = 'asset::furniture-and-fixtures'
    asset__global_tax_deferred = 'asset::global-tax-deferred'
    asset__global_tax_refund = 'asset::global-tax-refund'
    asset__goodwill = 'asset::goodwill'
    asset__intangible_assets_under_development = (
        'asset::intangible-assets-under-development'
    )
    asset__intangible_assets = 'asset::intangible-assets'
    asset__internal_transfers = 'asset::internal-transfers'
    asset__inventory = 'asset::inventory'
    asset__investment_mortgage_real_estate_loans = (
        'asset::investment-mortgage-real-estate-loans'
    )
    asset__investment_other = 'asset::investment-other'
    asset__investment_tax_exempt_securities = 'asset::investment-tax-exempt-securities'
    asset__investment_us_government_obligations = (
        'asset::investment-us-government-obligations'
    )
    asset__investments = 'asset::investments'
    asset__land_asset = 'asset::land-asset'
    asset__land = 'asset::land'
    asset__lease_buyout = 'asset::lease-buyout'
    asset__leasehold_improvements = 'asset::leasehold-improvements'
    asset__licenses = 'asset::licenses'
    asset__loans_to_officers = 'asset::loans-to-officers'
    asset__loans_to_others = 'asset::loans-to-others'
    asset__loans_to_stockholders = 'asset::loans-to-stockholders'
    asset__long_term_investments = 'asset::long-term-investments'
    asset__long_term_loans_and_advances_to_related_parties = (
        'asset::long-term-loans-and-advances-to-related-parties'
    )
    asset__machinery_and_equipment = 'asset::machinery-and-equipment'
    asset__money_market = 'asset::money-market'
    asset__non_current_assets = 'asset::non-current-assets'
    asset__organizational_costs = 'asset::organizational-costs'
    asset__other_asset = 'asset::other-asset'
    asset__other_consumables = 'asset::other-consumables'
    asset__other_current_asset = 'asset::other-current-asset'
    asset__other_current_assets = 'asset::other-current-assets'
    asset__other_ear_marked_bank_accounts = 'asset::other-ear-marked-bank-accounts'
    asset__other_fixed_assets = 'asset::other-fixed-assets'
    asset__other_intangible_assets = 'asset::other-intangible-assets'
    asset__other_long_term_assets = 'asset::other-long-term-assets'
    asset__other_long_term_investments = 'asset::other-long-term-investments'
    asset__other_long_term_loans_and_advances = (
        'asset::other-long-term-loans-and-advances'
    )
    asset__participating_interests = 'asset::participating-interests'
    asset__prepaid_expenses = 'asset::prepaid-expenses'
    asset__prepayments_and_accrued_income = 'asset::prepayments-and-accrued-income'
    asset__provisions_current_assets = 'asset::provisions-current-assets'
    asset__provisions_fixed_assets = 'asset::provisions-fixed-assets'
    asset__provisions_non_current_assets = 'asset::provisions-non-current-assets'
    asset__rents_held_in_trust = 'asset::rents-held-in-trust'
    asset__retainage = 'asset::retainage'
    asset__savings = 'asset::savings'
    asset__security_deposits = 'asset::security-deposits'
    asset__short_term_investments_in_related_parties = (
        'asset::short-term-investments-in-related-parties'
    )
    asset__short_term_loans_and_advances_to_related_parties = (
        'asset::short-term-loans-and-advances-to-related-parties'
    )
    asset__trade_and_other_receivables = 'asset::trade-and-other-receivables'
    asset__trust_accounts = 'asset::trust-accounts'
    asset__undeposited_funds = 'asset::undeposited-funds'
    asset__vehicles = 'asset::vehicles'
    asset = 'asset'
    cost_of_goods_sold__cost_of_labor_cos = 'cost-of-goods-sold::cost-of-labor-cos'
    cost_of_goods_sold__cost_of_sales = 'cost-of-goods-sold::cost-of-sales'
    cost_of_goods_sold__equipment_rental_cos = (
        'cost-of-goods-sold::equipment-rental-cos'
    )
    cost_of_goods_sold__freight_and_delivery_cost = (
        'cost-of-goods-sold::freight-and-delivery-cost'
    )
    cost_of_goods_sold__other_costs_of_service_cos = (
        'cost-of-goods-sold::other-costs-of-service-cos'
    )
    cost_of_goods_sold__shipping_freight_delivery_cos = (
        'cost-of-goods-sold::shipping-freight-delivery-cos'
    )
    cost_of_goods_sold__supplies_materials_cogs = (
        'cost-of-goods-sold::supplies-materials-cogs'
    )
    cost_of_goods_sold = 'cost-of-goods-sold'
    equity__accumulated_adjustment = 'equity::accumulated-adjustment'
    equity__accumulated_other_comprehensive_income = (
        'equity::accumulated-other-comprehensive-income'
    )
    equity__called_up_share_capital = 'equity::called-up-share-capital'
    equity__capital_reserves = 'equity::capital-reserves'
    equity__common_stock = 'equity::common-stock'
    equity__dividend_disbursed = 'equity::dividend-disbursed'
    equity__equity_in_earnings_of_subsidiuaries = (
        'equity::equity-in-earnings-of-subsidiuaries'
    )
    equity__estimated_taxes = 'equity::estimated-taxes'
    equity__funds = 'equity::funds'
    equity__healthcare = 'equity::healthcare'
    equity__investment_grants = 'equity::investment-grants'
    equity__money_received_against_share_warrants = (
        'equity::money-received-against-share-warrants'
    )
    equity__opening_balance_equity = 'equity::opening-balance-equity'
    equity__other_free_reserves = 'equity::other-free-reserves'
    equity__owners_equity = 'equity::owners-equity'
    equity__paid_in_capital_or_surplus = 'equity::paid-in-capital-or-surplus'
    equity__partner_contributions = 'equity::partner-contributions'
    equity__partner_distributions = 'equity::partner-distributions'
    equity__partners_equity = 'equity::partners-equity'
    equity__personal_expense = 'equity::personal-expense'
    equity__personal_income = 'equity::personal-income'
    equity__preferred_stock = 'equity::preferred-stock'
    equity__retained_earnings = 'equity::retained-earnings'
    equity__share_application_money_pending_allotment = (
        'equity::share-application-money-pending-allotment'
    )
    equity__share_capital = 'equity::share-capital'
    equity__treasury_stock = 'equity::treasury-stock'
    equity = 'equity'
    expense__advertising_promotional = 'expense::advertising-promotional'
    expense__amortization_expense = 'expense::amortization-expense'
    expense__appropriations_to_depreciation = 'expense::appropriations-to-depreciation'
    expense__auto = 'expense::auto'
    expense__bad_debts = 'expense::bad-debts'
    expense__bank_charges = 'expense::bank-charges'
    expense__borrowing_cost = 'expense::borrowing-cost'
    expense__charitable_contributions = 'expense::charitable-contributions'
    expense__commissions_and_fees = 'expense::commissions-and-fees'
    expense__commissions_and_fees_1 = 'expense::commissions-and-fees'
    expense__cost_of_labor = 'expense::cost-of-labor'
    expense__distribution_costs = 'expense::distribution-costs'
    expense__dues_subscriptions = 'expense::dues-subscriptions'
    expense__entertainment_meals = 'expense::entertainment-meals'
    expense__entertainment = 'expense::entertainment'
    expense__equipment_rental = 'expense::equipment-rental'
    expense__external_services = 'expense::external-services'
    expense__extraordinary_charges = 'expense::extraordinary-charges'
    expense__finance_costs = 'expense::finance-costs'
    expense__global_tax_expense = 'expense::global-tax-expense'
    expense__income_tax_expense = 'expense::income-tax-expense'
    expense__insurance = 'expense::insurance'
    expense__interest_paid = 'expense::interest-paid'
    expense__legal_professional_fees = 'expense::legal-professional-fees'
    expense__loss_on_discontinued_operations_net_of_tax = (
        'expense::loss-on-discontinued-operations-net-of-tax'
    )
    expense__management_compensation = 'expense::management-compensation'
    expense__office_expenses = 'expense::office-expenses'
    expense__office_general_administrative_expenses = (
        'expense::office-general-administrative-expenses'
    )
    expense__other_business_expenses = 'expense::other-business-expenses'
    expense__other_current_operating_charges = (
        'expense::other-current-operating-charges'
    )
    expense__other_external_services = 'expense::other-external-services'
    expense__other_miscellaneous_service_cost = (
        'expense::other-miscellaneous-service-cost'
    )
    expense__other_rental_costs = 'expense::other-rental-costs'
    expense__other_selling_expenses = 'expense::other-selling-expenses'
    expense__payroll_expenses = 'expense::payroll-expenses'
    expense__penalties_settlements = 'expense::penalties-settlements'
    expense__project_studies_surveys_assessments = (
        'expense::project-studies-surveys-assessments'
    )
    expense__promotional_meals = 'expense::promotional-meals'
    expense__purchases_rebates = 'expense::purchases-rebates'
    expense__rent_or_lease_of_buildings = 'expense::rent-or-lease-of-buildings'
    expense__repair_maintenance = 'expense::repair-maintenance'
    expense__shipping_and_delivery_expense = 'expense::shipping-and-delivery-expense'
    expense__shipping_freight_delivery = 'expense::shipping-freight-delivery'
    expense__staff_costs = 'expense::staff-costs'
    expense__sundry = 'expense::sundry'
    expense__supplies_materials = 'expense::supplies-materials'
    expense__taxes_paid = 'expense::taxes-paid'
    expense__travel_expenses_general_and_admin_expenses = (
        'expense::travel-expenses-general-and-admin-expenses'
    )
    expense__travel_expenses_selling_expense = (
        'expense::travel-expenses-selling-expense'
    )
    expense__travel_meals = 'expense::travel-meals'
    expense__travel = 'expense::travel'
    expense__unapplied_cash_bill_payment_expense = (
        'expense::unapplied-cash-bill-payment-expense'
    )
    expense__utilities = 'expense::utilities'
    expense__utilities_1 = 'expense::utilities'
    expense = 'expense'
    income = 'income'
    liability__accounts_payable = 'liability::accounts-payable'
    liability__accruals_and_deferred_income = 'liability::accruals-and-deferred-income'
    liability__accrued_long_term_liabilities = (
        'liability::accrued-long-term-liabilities'
    )
    liability__accrued_vacation_payable = 'liability::accrued-vacation-payable'
    liability__bank_loans = 'liability::bank-loans'
    liability__credit_card = 'liability::credit-card'
    liability__debts_related_to_participating_interests = (
        'liability::debts-related-to-participating-interests'
    )
    liability__deferred_tax_liabilities = 'liability::deferred-tax-liabilities'
    liability__government_and_other_public_authorities = (
        'liability::government-and-other-public-authorities'
    )
    liability__group_and_associates = 'liability::group-and-associates'
    liability__liabilities_related_to_assets_held_for_sale = (
        'liability::liabilities-related-to-assets-held-for-sale'
    )
    liability__long_term_borrowings = 'liability::long-term-borrowings'
    liability__long_term_debit = 'liability::long-term-debit'
    liability__long_term_employee_benefit_obligations = (
        'liability::long-term-employee-benefit-obligations'
    )
    liability__long_term_liability = 'liability::long-term-liability'
    liability__notes_payable = 'liability::notes-payable'
    liability__obligations_under_finance_leases = (
        'liability::obligations-under-finance-leases'
    )
    liability__other_long_term_liabilities = 'liability::other-long-term-liabilities'
    liability__other_long_term_provisions = 'liability::other-long-term-provisions'
    liability__outstanding_dues_micro_small_enterprise = (
        'liability::outstanding-dues-micro-small-enterprise'
    )
    liability__outstanding_dues_other_than_micro_small_enterprise = (
        'liability::outstanding-dues-other-than-micro-small-enterprise'
    )
    liability__provision_for_liabilities = 'liability::provision-for-liabilities'
    liability__provisions_non_current_liabilities = (
        'liability::provisions-non-current-liabilities'
    )
    liability__shareholder_notes_payable = 'liability::shareholder-notes-payable'
    liability__staff_and_related_long_term_liability_accounts = (
        'liability::staff-and-related-long-term-liability-accounts'
    )
    liability = 'liability'
    other_current_liability__accrued_liabilities = (
        'other-current-liability::accrued-liabilities'
    )
    other_current_liability__current_liabilities = (
        'other-current-liability::current-liabilities'
    )
    other_current_liability__current_portion_employee_benefits_obligations = (
        'other-current-liability::current-portion-employee-benefits-obligations'
    )
    other_current_liability__current_portion_of_obligations_under_finance_leases = (
        'other-current-liability::current-portion-of-obligations-under-finance-leases'
    )
    other_current_liability__current_tax_liability = (
        'other-current-liability::current-tax-liability'
    )
    other_current_liability__direct_deposit_payable = (
        'other-current-liability::direct-deposit-payable'
    )
    other_current_liability__dividends_payable = (
        'other-current-liability::dividends-payable'
    )
    other_current_liability__duties_and_taxes = (
        'other-current-liability::duties-and-taxes'
    )
    other_current_liability__federal_income_tax_payable = (
        'other-current-liability::federal-income-tax-payable'
    )
    other_current_liability__global_tax_payable = (
        'other-current-liability::global-tax-payable'
    )
    other_current_liability__global_tax_suspense = (
        'other-current-liability::global-tax-suspense'
    )
    other_current_liability__insurance_payable = (
        'other-current-liability::insurance-payable'
    )
    other_current_liability__interest_payables = (
        'other-current-liability::interest-payables'
    )
    other_current_liability__line_of_credit = 'other-current-liability::line-of-credit'
    other_current_liability__loan_payable = 'other-current-liability::loan-payable'
    other_current_liability__other_current_liabilities = (
        'other-current-liability::other-current-liabilities'
    )
    other_current_liability__payroll_clearing = (
        'other-current-liability::payroll-clearing'
    )
    other_current_liability__payroll_tax_payable = (
        'other-current-liability::payroll-tax-payable'
    )
    other_current_liability__prepaid_expenses_payable = (
        'other-current-liability::prepaid-expenses-payable'
    )
    other_current_liability__provision_for_warranty_obligations = (
        'other-current-liability::provision-for-warranty-obligations'
    )
    other_current_liability__provisions_current_liabilities = (
        'other-current-liability::provisions-current-liabilities'
    )
    other_current_liability__rents_in_trust_liability = (
        'other-current-liability::rents-in-trust-liability'
    )
    other_current_liability__sales_tax_payable = (
        'other-current-liability::sales-tax-payable'
    )
    other_current_liability__short_term_borrowings = (
        'other-current-liability::short-term-borrowings'
    )
    other_current_liability__social_security_agencies = (
        'other-current-liability::social-security-agencies'
    )
    other_current_liability__staff_and_related_liability_accounts = (
        'other-current-liability::staff-and-related-liability-accounts'
    )
    other_current_liability__state_local_income_tax_payable = (
        'other-current-liability::state-local-income-tax-payable'
    )
    other_current_liability__sundry_debtors_and_creditors = (
        'other-current-liability::sundry-debtors-and-creditors'
    )
    other_current_liability__trade_and_other_payables = (
        'other-current-liability::trade-and-other-payables'
    )
    other_current_liability__trust_accounts_liabilities = (
        'other-current-liability::trust-accounts-liabilities'
    )
    other_current_liability = 'other-current-liability'
    other_expense__amortization = 'other-expense::amortization'
    other_expense__deferred_tax_expense = 'other-expense::deferred-tax-expense'
    other_expense__depletion = 'other-expense::depletion'
    other_expense__depreciation = 'other-expense::depreciation'
    other_expense__exceptional_items = 'other-expense::exceptional-items'
    other_expense__exchange_gain_or_loss = 'other-expense::exchange-gain-or-loss'
    other_expense__extraordinary_items = 'other-expense::extraordinary-items'
    other_expense__gas_and_fuel = 'other-expense::gas-and-fuel'
    other_expense__home_office = 'other-expense::home-office'
    other_expense__home_owner_rental_insurance = (
        'other-expense::home-owner-rental-insurance'
    )
    other_expense__income_tax_other_expense = 'other-expense::income-tax-other-expense'
    other_expense__mat_credit = 'other-expense::mat-credit'
    other_expense__mortgage_interest = 'other-expense::mortgage-interest'
    other_expense__other_home_office_expenses = (
        'other-expense::other-home-office-expenses'
    )
    other_expense__other_miscellaneous_expense = (
        'other-expense::other-miscellaneous-expense'
    )
    other_expense__other_vehicle_expenses = 'other-expense::other-vehicle-expenses'
    other_expense__parking_and_tolls = 'other-expense::parking-and-tolls'
    other_expense__penalties_settlements = 'other-expense::penalties-settlements'
    other_expense__prior_period_items = 'other-expense::prior-period-items'
    other_expense__rent_and_lease = 'other-expense::rent-and-lease'
    other_expense__repairs_and_maintenance = 'other-expense::repairs-and-maintenance'
    other_expense__tax_roundoff_gain_or_loss = (
        'other-expense::tax-roundoff-gain-or-loss'
    )
    other_expense__utilities = 'other-expense::utilities'
    other_expense__vehicle_insurance = 'other-expense::vehicle-insurance'
    other_expense__vehicle_lease = 'other-expense::vehicle-lease'
    other_expense__vehicle_loan_interest = 'other-expense::vehicle-loan-interest'
    other_expense__vehicle_loan = 'other-expense::vehicle-loan'
    other_expense__vehicle_registration = 'other-expense::vehicle-registration'
    other_expense__vehicle_repairs = 'other-expense::vehicle-repairs'
    other_expense__vehicle = 'other-expense::vehicle'
    other_expense__wash_and_road_services = 'other-expense::wash-and-road-services'
    other_expense = 'other-expense'
    other_income__dividend_income = 'other-income::dividend-income'
    other_income__gain_loss_on_sale_of_fixed_assets = (
        'other-income::gain-loss-on-sale-of-fixed-assets'
    )
    other_income__gain_loss_on_sale_of_investments = (
        'other-income::gain-loss-on-sale-of-investments'
    )
    other_income__interest_earned = 'other-income::interest-earned'
    other_income__loss_on_disposal_of_assets = (
        'other-income::loss-on-disposal-of-assets'
    )
    other_income__other_investment_income = 'other-income::other-investment-income'
    other_income__other_miscellaneous_income = (
        'other-income::other-miscellaneous-income'
    )
    other_income__other_operating_income = 'other-income::other-operating-income'
    other_income__tax_exempt_interest = 'other-income::tax-exempt-interest'
    other_income__unrealised_loss_on_securities_net_of_tax = (
        'other-income::unrealised-loss-on-securities-net-of-tax'
    )
    other_income = 'other-income'
    revenue__cash_receipt_income = 'revenue::cash-receipt-income'
    revenue__discounts_refunds_given = 'revenue::discounts-refunds-given'
    revenue__income = 'revenue::income'
    revenue__non_profit_income = 'revenue::non-profit-income'
    revenue__operating_grants = 'revenue::operating-grants'
    revenue__other_current_operating_income = 'revenue::other-current-operating-income'
    revenue__other_primary_income = 'revenue::other-primary-income'
    revenue__own_work_capitalized = 'revenue::own-work-capitalized'
    revenue__revenue_general = 'revenue::revenue-general'
    revenue__sales_of_product_income = 'revenue::sales-of-product-income'
    revenue__sales_retail = 'revenue::sales-retail'
    revenue__sales_wholesale = 'revenue::sales-wholesale'
    revenue__savings_by_tax_scheme = 'revenue::savings-by-tax-scheme'
    revenue__service_fee_income = 'revenue::service-fee-income'
    revenue__unapplied_cash_payment_income = 'revenue::unapplied-cash-payment-income'


class Format(Enum):
    json = 'json'
    xml = 'xml'


class Webhooks(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    address: Optional[str] = None
    objects: Optional[List[str]] = None
    events: Optional[List[str]] = None
    format: Optional[Format] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    isDeleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class MessageContentType(Enum):
    text = 'text'
    image = 'image'
    video = 'video'
    file = 'file'
    location = 'location'
    sticker = 'sticker'
    contact = 'contact'
    audio = 'audio'
    link = 'link'
    document = 'document'
    gif = 'gif'
    voice = 'voice'
    html = 'html'


class MessageDeliveryStatus(Enum):
    sent = 'sent'
    delivered = 'delivered'
    read = 'read'
    failed = 'failed'
    pending = 'pending'
    error = 'error'
    undeliverable = 'undeliverable'


class MessageReadStatus(Enum):
    unsent = 'unsent'
    sent = 'sent'
    delivered = 'delivered'
    read = 'read'
    failed = 'failed'


class ReactionType(Enum):
    like = 'like'
    dislike = 'dislike'
    laugh = 'laugh'
    sad = 'sad'
    angry = 'angry'
    love = 'love'
    bookmark = 'bookmark'
    wow = 'wow'
    interested = 'interested'


class ReceiverRole(Enum):
    User = 'User'
    Admin = 'Admin'
    Moderator = 'Moderator'


class PrerequisiteRangeType(Enum):
    subtotal = 'subtotal'
    quantity = 'quantity'
    shipping_price = 'shipping-price'


class TargetType(Enum):
    line_item = 'line-item'
    shipping_line = 'shipping-line'


class TargetSelection(Enum):
    all = 'all'
    entitled = 'entitled'


class AllocationMethod(Enum):
    across = 'across'
    each = 'each'


class CustomerSelection(Enum):
    all = 'all'
    prerequisite = 'prerequisite'


class ChatType(Enum):
    private = 'private'
    group = 'group'
    public = 'public'


class CommunicationRole(Enum):
    user = 'user'
    assistant = 'assistant'
    bot = 'bot'
    admin = 'admin'
    moderator = 'moderator'
    owner = 'owner'
    member = 'member'
    guest = 'guest'
    group = 'group'
    channel = 'channel'
    service = 'service'
    system = 'system'


class ConversationStatus(Enum):
    active = 'active'
    archived = 'archived'
    closed = 'closed'
    snoozed = 'snoozed'
    deleted = 'deleted'


class ParticipantEngagementStatus(Enum):
    active = 'active'
    inactive = 'inactive'
    left = 'left'
    banned = 'banned'
    admin = 'admin'
    guest = 'guest'
    moderator = 'moderator'


class AiUsage(BaseModel):
    commonModel: Optional[str] = None
    promptTokens: Optional[float] = None
    completionTokens: Optional[float] = None
    totalTokens: Optional[float] = None


class AiMessagesContentType(Enum):
    text = 'text'
    image = 'image'
    tool_use = 'tool-use'
    tool_result = 'tool-result'


class AiRole(Enum):
    user = 'user'
    assistant = 'assistant'
    tool = 'tool'


class AiToolChoiceType(Enum):
    any = 'any'
    auto = 'auto'
    tool = 'tool'
    none = 'none'


class JsonSchemaType(Enum):
    function = 'function'


class ResponseFormatType(Enum):
    text = 'text'
    json_object = 'json-object'
    json_schema = 'json-schema'


class ToolCallType(Enum):
    function = 'function'


class Records(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    entity: Optional[Dict[str, Any]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class Objects(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    singularNoun: Optional[str] = None
    pluralNoun: Optional[str] = None
    slug: Optional[str] = None
    custom: Optional[bool] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class ModifierType(Enum):
    list = 'list'
    text = 'text'


class ModifierGroups(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    type: Optional[ModifierType] = None
    modifiers: Optional[List[Modifiers]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class TimeSession(BaseModel):
    commonModel: Optional[str] = None
    openTime: Optional[str] = None
    closeTime: Optional[str] = None


class DayOfWeek(Enum):
    monday = 'monday'
    tuesday = 'tuesday'
    wednesday = 'wednesday'
    thursday = 'thursday'
    friday = 'friday'
    saturday = 'saturday'
    sunday = 'sunday'


class CreditNoteStatus(Enum):
    draft = 'draft'
    issued = 'issued'
    applied = 'applied'
    void = 'void'
    disputed = 'disputed'
    pending = 'pending'
    cancelled = 'cancelled'
    completed = 'completed'
    revised = 'revised'


class CreditType(Enum):
    goodwill = 'goodwill'
    prepayment = 'prepayment'
    supplier = 'supplier'
    customer = 'customer'
    overpayment = 'overpayment'


class Drives(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None


class Sentences(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    speakerId: Optional[str] = None
    speakerName: Optional[str] = None
    sentence: Optional[str] = None
    startTime: Optional[datetime] = None
    endTime: Optional[datetime] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class Transcripts(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    topic: Optional[str] = None
    meetingId: Optional[str] = None
    speakerId: Optional[str] = None
    speakerName: Optional[str] = None
    sentences: Optional[List[Sentences]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class ParentFolders(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None


class FileOwners(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    email: Optional[EmailStr] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None


class FileType(Enum):
    file = 'file'
    folder = 'folder'
    url = 'url'


class Calendars(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    type: Optional[str] = None
    location: Optional[str] = None
    timeZone: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class CallDirection(Enum):
    inbound = 'inbound'
    outbound = 'outbound'
    conference = 'conference'
    unknown = 'unknown'


class SpeakerRole(Enum):
    invitee = 'invitee'
    attendee = 'attendee'


class EntryPoints(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    type: Optional[str] = None
    uri: Optional[AnyUrl] = None
    name: Optional[str] = None
    pin: Optional[str] = None


class EventRules(BaseModel):
    commonModel: Optional[str] = None
    canAddSelf: Optional[bool] = None
    guestsCanInvite: Optional[bool] = None
    guestsCanModify: Optional[bool] = None
    locked: Optional[bool] = None
    isAllDay: Optional[bool] = None
    isMultiDay: Optional[bool] = None


class EventFrequency(Enum):
    daily = 'daily'
    weekly = 'weekly'
    monthly = 'monthly'
    yearly = 'yearly'


class EventReminderAction(Enum):
    email = 'email'
    popup = 'popup'


class EventRuleType(Enum):
    repeat = 'repeat'
    exclude = 'exclude'
    add_dates = 'add-dates'
    exclude_dates = 'exclude-dates'


class EventStatus(Enum):
    confirmed = 'confirmed'
    tentative = 'tentative'
    cancelled = 'cancelled'


class EventVisibility(Enum):
    public = 'public'
    private = 'private'
    confidential = 'confidential'


class Phones(BaseModel):
    commonModel: Optional[str] = None
    phone: Optional[str] = None
    country: Optional[str] = None
    countryCode: Optional[str] = None
    type: Optional[DeviceUsageType] = None


class Metadata(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    key: Optional[str] = None
    value: Optional[str] = None
    type: Optional[DataType] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    entityId: Optional[str] = None
    entityType: Optional[str] = None
    valueParsingRequired: Optional[bool] = None


class Emails(BaseModel):
    commonModel: Optional[str] = None
    email: Optional[EmailStr] = None
    type: Optional[EmailCategoryType] = None


class SocialProfiles(BaseModel):
    commonModel: Optional[str] = None
    type: Optional[SocialPlatform] = None
    username: Optional[str] = None
    displayName: Optional[str] = None
    url: Optional[str] = None
    avatarUrl: Optional[str] = None
    email: Optional[EmailStr] = None
    additionalInfo: Optional[Metadata] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class Entity(BaseModel):
    commonModel: Optional[str] = None
    entityId: Optional[str] = None
    entityType: Optional[EntityCategory] = None
    value: Optional[str] = None
    attributes: Optional[List[str]] = None


class CustomAttributes(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    fieldName: Optional[str] = None
    fieldValue: Optional[str] = None
    fieldType: Optional[DataType] = None


class Addresses(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    contactId: Optional[str] = None
    accountId: Optional[str] = None
    firstName: Optional[str] = None
    middleName: Optional[str] = None
    lastName: Optional[str] = None
    name: Optional[str] = None
    companyName: Optional[str] = None
    email: Optional[EmailStr] = None
    phone: Optional[str] = None
    street: Optional[str] = None
    addressLine2: Optional[str] = None
    city: Optional[str] = None
    province: Optional[str] = None
    region: Optional[str] = None
    postalCode: Optional[str] = None
    postalCodeExtension: Optional[str] = None
    country: Optional[str] = None
    countryCode: Optional[str] = None
    type: Optional[ContactAddressType] = None
    geoLocation: Optional[GeoCoordinates] = None
    customFields: Optional[List[CustomAttributes]] = None
    subdivisionCode: Optional[str] = None


class Customers(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    reference: Optional[Entity] = None
    title: Optional[str] = None
    fullName: Optional[str] = None
    firstName: Optional[str] = None
    middleName: Optional[str] = None
    lastName: Optional[str] = None
    email: Optional[EmailStr] = None
    emails: Optional[List[Emails]] = None
    phoneNumber: Optional[str] = None
    phones: Optional[List[Phones]] = None
    dateOfBirth: Optional[datetime] = None
    addresses: Optional[List[Addresses]] = None
    defaultAddress: Optional[Addresses] = None
    customerNumber: Optional[str] = None
    jobTitle: Optional[str] = None
    company: Optional[str] = None
    companyId: Optional[str] = None
    currency: Optional[Currency] = None
    notes: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    status: Optional[CustomerStatus] = None
    customerSegment: Optional[str] = None
    customerType: Optional[CustomerType] = None
    loyaltyProgramMembership: Optional[str] = None
    preferredContactMethod: Optional[CommunicationMethod] = None
    tags: Optional[List[str]] = None
    metadata: Optional[str] = None
    socialProfiles: Optional[List[SocialProfiles]] = None
    source: Optional[str] = None
    customFields: Optional[List[CustomAttributes]] = None
    modifyToken: Optional[str] = None


class PaymentMethods(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    type: Optional[PaymentMethod] = None
    details: Optional[str] = None
    isDefault: Optional[bool] = None


class SSO(BaseModel):
    commonModel: Optional[str] = None
    provider: Optional[IdentityProvider] = None
    providerUserId: Optional[str] = None
    profileUrl: Optional[str] = None
    accessToken: Optional[str] = None
    refreshToken: Optional[str] = None
    expiresIn: Optional[float] = None
    expiryDate: Optional[datetime] = None
    scopes: Optional[List[str]] = None
    tokenType: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class Images(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    src: Optional[str] = None
    data: Optional[str] = None
    altText: Optional[str] = None
    width: Optional[float] = None
    height: Optional[float] = None
    thumbnailSrc: Optional[str] = None
    caption: Optional[str] = None
    title: Optional[str] = None
    mimeType: Optional[ImageMimeType] = None
    tags: Optional[List[str]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    type: Optional[ImageType] = None


class Users(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    firstName: Optional[str] = None
    middleName: Optional[str] = None
    lastName: Optional[str] = None
    email: Optional[EmailStr] = None
    username: Optional[str] = None
    password: Optional[SecretStr] = None
    profilePicture: Optional[Images] = None
    coverPhoto: Optional[Images] = None
    gender: Optional[Gender] = None
    dateOfBirth: Optional[datetime] = None
    phoneNumber: Optional[str] = None
    isActive: Optional[bool] = None
    lastLogin: Optional[datetime] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    addresses: Optional[List[Addresses]] = None
    roles: Optional[List[Role]] = None
    preferences: Optional[Preferences] = None
    bio: Optional[str] = None
    website: Optional[str] = None
    socialProfiles: Optional[List[SocialProfiles]] = None
    status: Optional[UserStatus] = None
    sso: Optional[List[SSO]] = None
    paymentMethods: Optional[PaymentMethods] = None
    modifyToken: Optional[str] = None


class UserOrGroup(BaseModel):
    commonModel: Optional[str] = None
    identifier: Optional[str] = None
    displayName: Optional[str] = None
    type: Optional[ParticipantType] = None


class Permissions(BaseModel):
    commonModel: Optional[str] = None
    canView: Optional[List[str]] = None
    canEdit: Optional[List[str]] = None
    canDelete: Optional[List[str]] = None
    roles: Optional[List[str]] = None
    accessControlType: Optional[AccessControlModel] = None
    assigneeDetails: Optional[UserOrGroup] = None
    identifierType: Optional[UniversalIdentifierType] = None


class Discounts(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    type: Optional[DiscountType] = None
    value: Optional[float] = None
    currency: Optional[str] = None
    code: Optional[str] = None
    usageLimit: Optional[float] = None
    usageLimitPerCustomer: Optional[float] = None
    usageLimitExpirations: Optional[UsageLimitExpirations] = None
    appliesTo: Optional[AppliesTo] = None
    customerEligibility: Optional[CustomerEligibility] = None
    minimumRequirements: Optional[MinimumRequirements] = None
    minimumPurchaseAmount: Optional[float] = None
    minimumQuantityOfItems: Optional[float] = None
    startDate: Optional[datetime] = None
    endDate: Optional[datetime] = None
    status: Optional[Status] = None
    timesUsed: Optional[float] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    exclusions: Optional[List[str]] = None
    channelAvailability: Optional[ChannelAvailability] = None
    stackable: Optional[bool] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    customFields: Optional[List[CustomAttributes]] = None
    modifyToken: Optional[str] = None


class Taxes(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    code: Optional[str] = None
    taxable: Optional[bool] = None
    rate: Optional[float] = None
    currency: Optional[Currency] = None
    type: Optional[TaxType] = None
    country: Optional[str] = None
    region: Optional[str] = None
    description: Optional[str] = None
    amount: Optional[float] = None
    category: Optional[str] = None
    jurisdiction: Optional[str] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class TaxLines(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    price: Optional[float] = None
    rate: Optional[float] = None
    name: Optional[str] = None
    title: Optional[str] = None
    taxCode: Optional[str] = None
    isCompound: Optional[bool] = None
    isNonRecoverable: Optional[bool] = None
    isInclusive: Optional[bool] = None
    metadata: Optional[Metadata] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class Variants(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    productId: Optional[str] = None
    title: Optional[str] = None
    sku: Optional[str] = None
    price: Optional[float] = None
    compareAtPrice: Optional[float] = None
    inventoryQuantity: Optional[float] = None
    weight: Optional[float] = None
    weightUnit: Optional[str] = None
    requiresShipping: Optional[bool] = None
    isDefault: Optional[bool] = None
    taxable: Optional[bool] = None
    barcode: Optional[str] = None
    imageId: Optional[float] = None
    dimensions: Optional[Dimensions] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    status: Optional[ItemAvailabilityStatus] = None
    modifyToken: Optional[str] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class RatingsReviews(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    storeID: Optional[str] = None
    rating: Optional[float] = None
    review: Optional[str] = None
    reviewerName: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    verifiedPurchase: Optional[bool] = None
    locale: Optional[str] = None
    status: Optional[ReviewApprovalStatus] = None
    metadata: Optional[Metadata] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class InvoiceItems(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    price: Optional[float] = None
    currency: Optional[Currency] = None
    quantity: Optional[float] = None
    isAvailable: Optional[bool] = None
    availabilityDate: Optional[datetime] = None
    tags: Optional[List[str]] = None
    imageUrl: Optional[str] = None
    gallery: Optional[List[Images]] = None
    brand: Optional[str] = None
    condition: Optional[ItemCondition] = None
    dimensions: Optional[Dimensions] = None
    weight: Optional[float] = None
    inventoryQuantity: Optional[float] = None
    inventoryStatus: Optional[ProductAvailabilityStatus] = None
    onSale: Optional[bool] = None
    discount: Optional[float] = None
    sku: Optional[str] = None
    upc: Optional[str] = None
    ean: Optional[str] = None
    isbn: Optional[str] = None
    mpn: Optional[str] = None
    variants: Optional[List[Variants]] = None
    options: Optional[List[ProductOptions]] = None
    reviews: Optional[List[RatingsReviews]] = None
    rating: Optional[float] = None
    ratingCount: Optional[float] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deletedAt: Optional[datetime] = None
    active: Optional[bool] = None
    modifyToken: Optional[str] = None


class Brands(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    logo: Optional[str] = None
    website: Optional[str] = None
    established: Optional[datetime] = None
    country: Optional[str] = None
    status: Optional[ItemEntityStatus] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None


class Salaries(BaseModel):
    commonModel: Optional[str] = None
    value: Optional[float] = None
    currency: Optional[Currency] = None
    paymentPeriod: Optional[TimeCycle] = None


class AuditInformation(BaseModel):
    commonModel: Optional[str] = None
    auditorName: Optional[str] = None
    auditOpinion: Optional[AuditOpinionType] = None
    auditDate: Optional[datetime] = None
    notes: Optional[str] = None


class BalanceSheets(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    balanceDate: Optional[datetime] = None
    currency: Optional[Currency] = None
    accountsReceivable: Optional[float] = None
    inventory: Optional[float] = None
    prepaidExpenses: Optional[float] = None
    fixedAssets: Optional[float] = None
    intangibleAssets: Optional[float] = None
    accountsPayable: Optional[float] = None
    accruedLiabilities: Optional[float] = None
    longTermDebt: Optional[float] = None
    equity: Optional[float] = None
    retainedEarnings: Optional[float] = None
    cashAndCashEquivalents: Optional[float] = None
    shortTermInvestments: Optional[float] = None
    propertyPlantEquipment: Optional[float] = None
    accumulatedDepreciation: Optional[float] = None
    shortTermDebt: Optional[float] = None
    taxLiabilities: Optional[float] = None
    deferredRevenue: Optional[float] = None
    otherCurrentLiabilities: Optional[float] = None
    otherCurrentAssets: Optional[float] = None
    otherNonCurrentLiabilities: Optional[float] = None
    otherNonCurrentAssets: Optional[float] = None
    commonStock: Optional[float] = None
    preferredStock: Optional[float] = None
    additionalPaidInCapital: Optional[float] = None
    treasuryStock: Optional[float] = None
    stockholdersEquity: Optional[float] = None
    minorityInterest: Optional[float] = None
    totalLiabilities: Optional[float] = None
    totalAssets: Optional[float] = None
    totalLiabilitiesAndEquity: Optional[float] = None
    currentAssets: Optional[float] = None
    nonCurrentAssets: Optional[float] = None
    currentLiabilities: Optional[float] = None
    nonCurrentLiabilities: Optional[float] = None
    notesPayable: Optional[float] = None
    currentPortionOfLongTermDebt: Optional[float] = None
    notes: Optional[str] = None
    auditInfo: Optional[AuditInformation] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    accountSummary: Optional[List[KeyValues]] = None
    customFields: Optional[List[CustomAttributes]] = None
    modifyToken: Optional[str] = None


class JournalEntryLines(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    accountId: Optional[str] = None
    description: Optional[str] = None
    debit: Optional[float] = None
    credit: Optional[float] = None
    amount: Optional[float] = None
    taxAmount: Optional[float] = None
    quantity: Optional[float] = None
    tracking: Optional[FinancialTrackingCategories] = None
    taxCode: Optional[str] = None


class InvoiceAdjustments(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    type: Optional[InvoiceAdjustmentType] = None
    amount: Optional[float] = None
    description: Optional[str] = None
    currency: Optional[Currency] = None
    appliedToInvoiceItemId: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    metadata: Optional[Metadata] = None


class PaymentTerms(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    description: Optional[str] = None
    type: Optional[PaymentTerm] = None
    dueDays: Optional[float] = None
    discountRate: Optional[float] = None
    discountDays: Optional[float] = None
    allowedMethods: Optional[List[str]] = None
    penaltyRate: Optional[float] = None
    interestRate: Optional[float] = None
    isActive: Optional[bool] = None
    currencyCode: Optional[str] = None
    permittedClientClasses: Optional[List[str]] = None
    notes: Optional[str] = None
    createdDate: Optional[datetime] = None
    lastUpdatedDate: Optional[datetime] = None
    gracePeriodDays: Optional[float] = None
    minimumPayment: Optional[float] = None
    countrySpecificTerms: Optional[List[str]] = None
    languageSupport: Optional[List[str]] = None
    currencyFormatting: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    isDeleted: Optional[bool] = None


class Vendors(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    accountNumber: Optional[str] = None
    currencyCode: Optional[str] = None
    tax: Optional[List[Taxes]] = None
    is1099: Optional[bool] = None
    note: Optional[str] = None
    outstandingBalance: Optional[float] = None
    overdueBalance: Optional[float] = None
    website: Optional[str] = None
    companyName: Optional[str] = None
    contactName: Optional[str] = None
    contactEmail: Optional[str] = None
    contactPhone: Optional[str] = None
    address: Optional[Addresses] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class TaxRates(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    taxNumber: Optional[str] = None
    country: Optional[str] = None
    region: Optional[str] = None
    percentage: Optional[float] = None
    name: Optional[str] = None
    shippingIncluded: Optional[bool] = None
    compound: Optional[bool] = None
    taxProvider: Optional[str] = None
    taxType: Optional[str] = None
    reportTaxType: Optional[str] = None
    displayRate: Optional[str] = None
    taxComponents: Optional[List[TaxLines]] = None
    applicableItems: Optional[List[str]] = None
    currency: Optional[Currency] = None
    customFields: Optional[List[CustomAttributes]] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    description: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class BillingDetails(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    customerId: Optional[str] = None
    fullName: Optional[str] = None
    email: Optional[EmailStr] = None
    phoneNumber: Optional[str] = None
    address: Optional[Addresses] = None
    companyName: Optional[str] = None
    vatId: Optional[str] = None
    paymentTerms: Optional[PaymentTerm] = None
    note: Optional[str] = None
    defaultPaymentMethod: Optional[PaymentMethods] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    isDeleted: Optional[bool] = None
    currency: Optional[Currency] = None
    language: Optional[str] = None
    additionalAttributes: Optional[List[CustomAttributes]] = None


class ShippingDetails(BaseModel):
    commonModel: Optional[str] = None
    method: Optional[str] = None
    estimatedDelivery: Optional[datetime] = None
    provider: Optional[str] = None
    trackingNumber: Optional[str] = None
    address: Optional[Addresses] = None
    price: Optional[float] = None
    insurance: Optional[bool] = None
    signatureRequired: Optional[bool] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class CardDetails(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    brand: Optional[str] = None
    status: Optional[str] = None
    lastFour: Optional[str] = None
    expiryMonth: Optional[str] = None
    expiryYear: Optional[str] = None
    fingerprint: Optional[str] = None
    type: Optional[CardType] = None
    prepaidType: Optional[PrepaidType] = None
    bin: Optional[str] = None
    entryMethod: Optional[EntryMethod] = None
    cvvStatus: Optional[CvvStatus] = None
    avcStatus: Optional[AvcStatus] = None
    statementDescription: Optional[str] = None
    modifyToken: Optional[str] = None
    capturedAt: Optional[datetime] = None
    authorizedAt: Optional[datetime] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deleted: Optional[bool] = None
    active: Optional[bool] = None


class Disputes(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    customerId: Optional[str] = None
    amount: Optional[float] = None
    currency: Optional[Currency] = None
    reason: Optional[str] = None
    status: Optional[FinancialDisputeStatus] = None
    evidence: Optional[Evidence] = None
    created: Optional[datetime] = None
    updated: Optional[datetime] = None
    chargeRefundable: Optional[bool] = None
    metadata: Optional[Metadata] = None
    charge: Optional[str] = None
    transactionId: Optional[str] = None
    notes: Optional[str] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    version: Optional[str] = None


class Reactions(BaseModel):
    commonModel: Optional[str] = None
    userId: Optional[str] = None
    messageId: Optional[str] = None
    chatId: Optional[str] = None
    type: Optional[ReactionType] = None
    createdAt: Optional[datetime] = None


class PrerequisiteRanges(BaseModel):
    commonModel: Optional[str] = None
    type: Optional[PrerequisiteRangeType] = None
    greaterThanOrEqualTo: Optional[float] = None
    lessThanOrEqualTo: Optional[float] = None


class PriceRules(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    targetType: Optional[TargetType] = None
    targetSelection: Optional[TargetSelection] = None
    allocationMethod: Optional[AllocationMethod] = None
    valueType: Optional[DiscountType] = None
    value: Optional[float] = None
    customerSelection: Optional[CustomerSelection] = None
    prerequisiteRanges: Optional[PrerequisiteRanges] = None
    prerequisiteCustomerIds: Optional[List[str]] = None
    prerequisiteSavedSearchIds: Optional[List[str]] = None
    prerequisiteCollectionIds: Optional[List[str]] = None
    prerequisiteProductIds: Optional[List[str]] = None
    prerequisiteVariantIds: Optional[List[str]] = None
    prerequisiteQuantity: Optional[float] = None
    currency: Optional[str] = None
    entitledProductIds: Optional[List[str]] = None
    entitledVariantIds: Optional[List[str]] = None
    entitledCollectionIds: Optional[List[str]] = None
    entitledCountryIds: Optional[List[str]] = None
    entitledQuantity: Optional[float] = None
    oncePerCustomer: Optional[bool] = None
    allocationLimit: Optional[float] = None
    usageLimit: Optional[float] = None
    startDate: Optional[datetime] = None
    endDate: Optional[datetime] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    priority: Optional[float] = None
    excludedProductIds: Optional[List[str]] = None
    excludedVariantIds: Optional[List[str]] = None
    excludedCollectionIds: Optional[List[str]] = None
    modifyToken: Optional[str] = None


class Participants(BaseModel):
    commonModel: Optional[str] = None
    userId: Optional[str] = None
    displayName: Optional[str] = None
    joinedAt: Optional[datetime] = None
    status: Optional[ParticipantEngagementStatus] = None
    type: Optional[CommunicationRole] = None


class ToolCalls(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    modifyToken: Optional[str] = None
    type: Optional[ToolCallType] = None
    function: Optional[Dict[str, Any]] = None


class JsonSchema(BaseModel):
    commonModel: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    strict: Optional[bool] = None
    schema_: Optional[Dict[str, Any]] = Field(None, alias='schema')
    type: Optional[JsonSchemaType] = None


class AiToolChoice(BaseModel):
    commonModel: Optional[str] = None
    name: Optional[str] = None
    type: Optional[AiToolChoiceType] = None


class ToolResultContent(BaseModel):
    commonModel: Optional[str] = None
    text: Optional[List[str]] = None
    type: Optional[AiMessagesContentType] = None
    image: Optional[Images] = None


class BusinessHours(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    dayOfWeek: Optional[DayOfWeek] = None
    sessions: Optional[List[TimeSession]] = None
    closed: Optional[bool] = None
    storeID: Optional[str] = None
    timeZone: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class Locations(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    businessName: Optional[str] = None
    description: Optional[str] = None
    countryCode: Optional[str] = None
    timezone: Optional[str] = None
    type: Optional[str] = None
    active: Optional[bool] = None
    address: Optional[Addresses] = None
    defaultEmail: Optional[str] = None
    emails: Optional[List[Emails]] = None
    defaultPhone: Optional[str] = None
    phones: Optional[List[Phones]] = None
    website: Optional[str] = None
    businessHours: Optional[List[BusinessHours]] = None
    domain: Optional[str] = None
    numberOfEmployees: Optional[float] = None
    currency: Optional[Currency] = None
    tags: Optional[List[str]] = None
    merchantId: Optional[str] = None
    merchantCategoryCode: Optional[str] = None
    socialProfiles: Optional[List[SocialProfiles]] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None
    locationNumber: Optional[str] = None


class Attributes(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    description: Optional[str] = None
    name: Optional[str] = None
    dataType: Optional[DataType] = None
    slug: Optional[str] = None
    required: Optional[bool] = None
    unique: Optional[bool] = None
    customTypeDetails: Optional[List[Metadata]] = None
    modifyToken: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None


class Tables(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    slug: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    fields: Optional[List[Attributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class Databases(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    tables: Optional[List[Tables]] = None
    permissionLevel: Optional[str] = None
    organizationId: Optional[str] = None
    url: Optional[str] = None
    region: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Files(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    size: Optional[float] = None
    extension: Optional[str] = None
    type: Optional[FileType] = None
    path: Optional[Path] = None
    mimeType: Optional[str] = None
    downloadable: Optional[bool] = None
    exportable: Optional[bool] = None
    downloadUrl: Optional[str] = None
    parent: Optional[ParentFolders] = None
    permissions: Optional[Permissions] = None
    owner: Optional[FileOwners] = None
    content: Optional[str] = None
    exportFormats: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class Speakers(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    speakerId: Optional[str] = None
    userId: Optional[str] = None
    name: Optional[str] = None
    email: Optional[EmailStr] = None
    title: Optional[str] = None
    role: Optional[SpeakerRole] = None


class Folders(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    description: Optional[str] = None
    size: Optional[float] = None
    parent: Optional[ParentFolders] = None
    owner: Optional[FileOwners] = None
    path: Optional[Path] = None
    downloadable: Optional[bool] = None
    permissions: Optional[Permissions] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class EventReminders(BaseModel):
    commonModel: Optional[str] = None
    minutes: Optional[float] = None
    action: Optional[EventReminderAction] = None


class EventRecurrenceRules(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    type: Optional[EventRuleType] = None
    frequency: Optional[EventFrequency] = None
    count: Optional[float] = None
    interval: Optional[float] = None
    until: Optional[datetime] = None
    byDay: Optional[str] = None
    byMonthDay: Optional[float] = None
    byMonth: Optional[float] = None
    dates: Optional[List[datetime]] = None


class Attachments(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    fileName: Optional[str] = None
    fileSize: Optional[float] = None
    fileType: Optional[str] = None
    url: Optional[str] = None
    thumbnailUrl: Optional[str] = None
    previewUrl: Optional[str] = None
    content: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    metadata: Optional[Metadata] = None
    associatedWith: Optional[Entity] = None
    permissions: Optional[Permissions] = None


class Notes(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    content: Optional[str] = None
    url: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    lastAccessed: Optional[datetime] = None
    reminder: Optional[datetime] = None
    color: Optional[str] = None
    priority: Optional[PriorityLevel] = None
    author: Optional[Users] = None
    tags: Optional[List[str]] = None
    attachments: Optional[List[Attachments]] = None
    sharedWith: Optional[List[Users]] = None
    visibility: Optional[ContentVisibility] = None
    metadata: Optional[List[str]] = None
    modifyToken: Optional[str] = None


class Campaigns(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    type: Optional[CampaignType] = None
    status: Optional[CampaignStatus] = None
    startDate: Optional[datetime] = None
    endDate: Optional[datetime] = None
    budget: Optional[float] = None
    targetAudience: Optional[str] = None
    channels: Optional[List[str]] = None
    performanceMetrics: Optional[PerformanceMetrics] = None
    creativeAssets: Optional[Attachments] = None
    tags: Optional[List[str]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class Contacts(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    firstName: Optional[str] = None
    lastName: Optional[str] = None
    code: Optional[str] = None
    leadId: Optional[str] = None
    company: Optional[str] = None
    defaultEmail: Optional[str] = None
    emails: Optional[List[Emails]] = None
    defaultPhone: Optional[str] = None
    phones: Optional[List[Phones]] = None
    address: Optional[Addresses] = None
    addresses: Optional[List[Addresses]] = None
    birthday: Optional[datetime] = None
    userRoles: Optional[List[UserRole]] = None
    relationship: Optional[str] = None
    note: Optional[str] = None
    notes: Optional[Notes] = None
    tags: Optional[List[str]] = None
    websites: Optional[List[str]] = None
    socialProfiles: Optional[List[SocialProfiles]] = None
    isActive: Optional[bool] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class Opportunities(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    amount: Optional[float] = None
    currency: Optional[Currency] = None
    stage: Optional[str] = None
    probability: Optional[float] = None
    closeDate: Optional[datetime] = None
    type: Optional[str] = None
    entity: Optional[Entity] = None
    companyId: Optional[str] = None
    nextStep: Optional[str] = None
    leadId: Optional[str] = None
    leadSource: Optional[str] = None
    isClosed: Optional[bool] = None
    isWon: Optional[bool] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    lostReason: Optional[str] = None
    campaign: Optional[Campaigns] = None
    contacts: Optional[List[Contacts]] = None
    owner: Optional[Users] = None
    attachments: Optional[List[Attachments]] = None
    notes: Optional[List[str]] = None
    customFields: Optional[List[CustomAttributes]] = None
    modifyToken: Optional[str] = None
    tags: Optional[List[str]] = None
    companyName: Optional[str] = None


class Items(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    accountId: Optional[str] = None
    accountName: Optional[str] = None
    parentId: Optional[str] = None
    productId: Optional[str] = None
    variantId: Optional[str] = None
    quantity: Optional[float] = None
    sku: Optional[str] = None
    price: Optional[float] = None
    currency: Optional[Currency] = None
    modifiers: Optional[List[Modifiers]] = None
    linePrice: Optional[float] = None
    originalPrice: Optional[float] = None
    discountedPrice: Optional[float] = None
    title: Optional[str] = None
    description: Optional[str] = None
    variantTitle: Optional[str] = None
    image: Optional[Images] = None
    weight: Optional[float] = None
    weightUnit: Optional[str] = None
    shippingId: Optional[str] = None
    requiresShipping: Optional[bool] = None
    taxable: Optional[bool] = None
    taxLines: Optional[List[TaxLines]] = None
    tax: Optional[float] = None
    discount: Optional[float] = None
    discountLines: Optional[List[Discounts]] = None
    fulfillableQuantity: Optional[float] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class Orders(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    reference: Optional[Entity] = None
    customerId: Optional[str] = None
    orderNumber: Optional[str] = None
    status: Optional[OrderStatus] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    total: Optional[float] = None
    subTotal: Optional[float] = None
    tip: Optional[float] = None
    tax: Optional[float] = None
    shippingCost: Optional[float] = None
    shippingId: Optional[str] = None
    storeLocationId: Optional[str] = None
    currency: Optional[Currency] = None
    paymentStatus: Optional[PaymentStatus] = None
    paymentMethods: Optional[List[str]] = None
    shippingMethod: Optional[str] = None
    shippingAddress: Optional[Addresses] = None
    billingAddress: Optional[Addresses] = None
    note: Optional[str] = None
    discounts: Optional[List[Discounts]] = None
    trackingInfo: Optional[str] = None
    items: Optional[List[Items]] = None
    tags: Optional[List[str]] = None
    taxes: Optional[List[Taxes]] = None
    modifyToken: Optional[str] = None


class Notifications(BaseModel):
    commonModel: Optional[str] = None
    notificationId: Optional[str] = None
    type: Optional[str] = None
    title: Optional[str] = None
    message: Optional[str] = None
    recipient: Optional[Users] = None
    status: Optional[str] = None
    priority: Optional[PriorityLevel] = None
    channel: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    customFields: Optional[List[CustomAttributes]] = None
    attachments: Optional[List[Attachments]] = None


class Comments(BaseModel):
    commonModel: Optional[str] = None
    commentId: Optional[str] = None
    author: Optional[Users] = None
    text: Optional[str] = None
    parentId: Optional[str] = None
    likes: Optional[float] = None
    flagged: Optional[bool] = None
    attachments: Optional[List[Attachments]] = None
    metadata: Optional[List[Metadata]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None


class Tasks(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    status: Optional[TaskStatus] = None
    priority: Optional[PriorityLevel] = None
    dueDate: Optional[datetime] = None
    dueTimezone: Optional[str] = None
    assignee: Optional[Users] = None
    createdBy: Optional[Users] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    labels: Optional[List[str]] = None
    comments: Optional[List[Comments]] = None
    attachments: Optional[List[Attachments]] = None
    timeEstimate: Optional[str] = None
    timeLogged: Optional[str] = None
    subTaskIds: Optional[List[str]] = None
    parentTaskId: Optional[str] = None
    dependOnTaskIds: Optional[List[str]] = None
    relatedToTaskId: Optional[List[str]] = None
    repeat: Optional[str] = None
    customFields: Optional[List[CustomAttributes]] = None
    watchers: Optional[List[Users]] = None
    completionPercentage: Optional[float] = None
    notifications: Optional[List[Notifications]] = None
    modifyToken: Optional[str] = None


class Leads(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    entity: Optional[Entity] = None
    companyId: Optional[str] = None
    name: Optional[str] = None
    firstName: Optional[str] = None
    middleName: Optional[str] = None
    lastName: Optional[str] = None
    opportunities: Optional[List[Opportunities]] = None
    defaultEmail: Optional[str] = None
    emails: Optional[List[Emails]] = None
    defaultPhone: Optional[str] = None
    phones: Optional[List[Phones]] = None
    companyName: Optional[str] = None
    jobTitle: Optional[str] = None
    website: Optional[str] = None
    leadSource: Optional[LeadSource] = None
    leadStatus: Optional[LeadLifecycleStatus] = None
    industry: Optional[str] = None
    numberOfEmployees: Optional[float] = None
    annualRevenue: Optional[float] = None
    addresses: Optional[List[Addresses]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    preferredContactMethod: Optional[CommunicationMethod] = None
    socialProfiles: Optional[List[SocialProfiles]] = None
    customFields: Optional[List[CustomAttributes]] = None
    notes: Optional[List[Notes]] = None
    modifyToken: Optional[str] = None


class Companies(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    reference: Optional[Entity] = None
    legalName: Optional[str] = None
    type: Optional[str] = None
    industry: Optional[str] = None
    address: Optional[Addresses] = None
    defaultEmail: Optional[str] = None
    emails: Optional[List[Emails]] = None
    defaultPhone: Optional[str] = None
    phones: Optional[List[Phones]] = None
    website: Optional[str] = None
    domain: Optional[str] = None
    foundedDate: Optional[datetime] = None
    numberOfEmployees: Optional[float] = None
    revenue: Optional[float] = None
    revenueCurrency: Optional[str] = None
    tags: Optional[List[str]] = None
    socialProfiles: Optional[List[SocialProfiles]] = None
    logo: Optional[str] = None
    description: Optional[str] = None
    stockSymbol: Optional[str] = None
    parentCompanyId: Optional[str] = None
    additionalContacts: Optional[List[Contacts]] = None
    incorporationCountry: Optional[str] = None
    incorporationDate: Optional[datetime] = None
    taxId: Optional[str] = None
    regulatoryStatus: Optional[str] = None
    dunsNumber: Optional[str] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None
    companyNumber: Optional[str] = None


class InventoryLocations(BaseModel):
    commonModel: Optional[str] = None
    locationId: Optional[str] = None
    name: Optional[str] = None
    address: Optional[Addresses] = None
    contactInformation: Optional[List[Contacts]] = None
    type: Optional[InventoryStorageType] = None
    quantity: Optional[float] = None
    operationalHours: Optional[str] = None
    isActive: Optional[bool] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deleted: Optional[bool] = None


class Products(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    reference: Optional[Entity] = None
    code: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    manufacturerName: Optional[str] = None
    prices: Optional[List[Prices]] = None
    sku: Optional[str] = None
    skuValidation: Optional[SkuValidation] = None
    images: Optional[List[Images]] = None
    variants: Optional[List[Variants]] = None
    options: Optional[List[ProductOptions]] = None
    categories: Optional[List[str]] = None
    tags: Optional[List[str]] = None
    vendor: Optional[str] = None
    brand: Optional[Brands] = None
    inventoryQuantity: Optional[float] = None
    inventoryLocation: Optional[InventoryLocations] = None
    availableForSale: Optional[bool] = None
    dimensions: Optional[Dimensions] = None
    weight: Optional[float] = None
    weightUnit: Optional[str] = None
    type: Optional[str] = None
    metaTitle: Optional[str] = None
    metaDescription: Optional[str] = None
    seoKeywords: Optional[List[str]] = None
    slug: Optional[str] = None
    accountIds: Optional[List[KeyValues]] = None
    customFields: Optional[List[CustomAttributes]] = None
    isDownloadable: Optional[bool] = None
    downloadFiles: Optional[List[Attachments]] = None
    relatedProducts: Optional[List[str]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    publishedAt: Optional[datetime] = None
    status: Optional[EntityLifecycleStatus] = None
    taxes: Optional[List[Taxes]] = None
    localizations: Optional[List[Localizations]] = None
    modifyToken: Optional[str] = None


class Tickets(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    companyId: Optional[str] = None
    typeId: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    status: Optional[IssueLifecycleStatus] = None
    priority: Optional[SupportTicketPriority] = None
    type: Optional[SupportQueryType] = None
    category: Optional[Categories] = None
    admin: Optional[Users] = None
    assignee: Optional[Users] = None
    reporter: Optional[Contacts] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    dueDate: Optional[datetime] = None
    attachments: Optional[List[Attachments]] = None
    comments: Optional[List[Comments]] = None
    notes: Optional[List[Notes]] = None
    tags: Optional[List[str]] = None
    customFields: Optional[List[CustomAttributes]] = None
    modifyToken: Optional[str] = None


class Jobs(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    employmentType: Optional[EmploymentType] = None
    location: Optional[Addresses] = None
    remote: Optional[bool] = None
    validUntil: Optional[datetime] = None
    company: Optional[Companies] = None
    baseSalary: Optional[Salaries] = None
    qualifications: Optional[str] = None
    responsibilities: Optional[str] = None
    skills: Optional[List[str]] = None
    benefits: Optional[List[str]] = None
    educationRequirements: Optional[str] = None
    experienceRequirements: Optional[str] = None
    workHours: Optional[str] = None
    industry: Optional[str] = None
    jobLocationType: Optional[str] = None
    occupationalCategory: Optional[str] = None
    incentiveCompensation: Optional[str] = None
    jobBenefits: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    employmentUnit: Optional[EmploymentUnits] = None
    jobImmediateStart: Optional[bool] = None
    jobFlexibleHours: Optional[bool] = None
    jobShifts: Optional[List[str]] = None
    jobTrainingProvided: Optional[bool] = None
    jobTrialPeriod: Optional[str] = None
    workFromHome: Optional[bool] = None
    languagesSpoken: Optional[List[str]] = None
    applicationDeadline: Optional[datetime] = None
    incentives: Optional[str] = None
    jobStartDate: Optional[datetime] = None
    salaryCurrency: Optional[str] = None
    modifyToken: Optional[str] = None


class JournalEntries(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    type: Optional[str] = None
    description: Optional[str] = None
    date: Optional[datetime] = None
    entryNumber: Optional[str] = None
    reference: Optional[str] = None
    memo: Optional[str] = None
    status: Optional[JournalEntryStatus] = None
    attachments: Optional[List[Attachments]] = None
    currency: Optional[Currency] = None
    exchangeRate: Optional[float] = None
    totalAmount: Optional[float] = None
    isReconciled: Optional[bool] = None
    lineItems: Optional[List[JournalEntryLines]] = None
    createdBy: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedBy: Optional[str] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Invoices(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    reference: Optional[Entity] = None
    invoiceNumber: Optional[str] = None
    vatName: Optional[str] = None
    vatNumber: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    dueDate: Optional[datetime] = None
    transactionDate: Optional[datetime] = None
    status: Optional[PaymentStatus] = None
    issuedDate: Optional[datetime] = None
    currency: Optional[Currency] = None
    subtotal: Optional[float] = None
    taxTotal: Optional[float] = None
    total: Optional[float] = None
    notes: Optional[str] = None
    terms: Optional[str] = None
    customer: Optional[Customers] = None
    items: Optional[List[InvoiceItems]] = None
    metadata: Optional[List[Metadata]] = None
    adjustments: Optional[List[InvoiceAdjustments]] = None
    billingAddress: Optional[Addresses] = None
    shippingAddress: Optional[Addresses] = None
    paymentTerms: Optional[PaymentTerms] = None
    discountTotal: Optional[float] = None
    discountPercentage: Optional[float] = None
    invoicePayments: Optional[List[InvoicePayments]] = None
    paidAmount: Optional[float] = None
    balanceDue: Optional[float] = None
    attachments: Optional[List[Attachments]] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    exchangeRate: Optional[float] = None
    header: Optional[str] = None
    footer: Optional[str] = None
    modifyToken: Optional[str] = None


class Candidates(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    firstName: Optional[str] = None
    lastName: Optional[str] = None
    email: Optional[EmailStr] = None
    phoneNumber: Optional[str] = None
    role: Optional[str] = None
    jobId: Optional[str] = None
    resume: Optional[Attachments] = None
    coverLetter: Optional[Attachments] = None
    profilePicture: Optional[Images] = None
    socialProfiles: Optional[List[SocialProfiles]] = None
    websites: Optional[List[str]] = None
    skills: Optional[List[str]] = None
    languages: Optional[List[str]] = None
    certifications: Optional[List[str]] = None
    educations: Optional[List[Educations]] = None
    workExperiences: Optional[List[WorkExperiences]] = None
    references: Optional[List[References]] = None
    availability: Optional[datetime] = None
    preferredWorkLocation: Optional[str] = None
    status: Optional[EmploymentAndCandidateStatus] = None
    customFields: Optional[List[CustomAttributes]] = None
    notes: Optional[List[Notes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class Bills(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    invoiceNumber: Optional[str] = None
    status: Optional[BillingStatus] = None
    issueDate: Optional[datetime] = None
    dueDate: Optional[datetime] = None
    currencyCode: Optional[str] = None
    amountDue: Optional[float] = None
    amountPaid: Optional[float] = None
    amountRemaining: Optional[float] = None
    vendor: Optional[Vendors] = None
    customer: Optional[Customers] = None
    lineItems: Optional[List[Items]] = None
    notes: Optional[str] = None
    terms: Optional[str] = None
    attachments: Optional[List[Attachments]] = None
    customFields: Optional[List[CustomAttributes]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class PurchaseOrders(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    orderNumber: Optional[str] = None
    status: Optional[OrderStatus] = None
    orderDate: Optional[datetime] = None
    accountId: Optional[str] = None
    expectedDeliveryDate: Optional[datetime] = None
    vendor: Optional[Vendors] = None
    shipTo: Optional[Addresses] = None
    billTo: Optional[Addresses] = None
    lineItems: Optional[List[PurchaseOrderLineItems]] = None
    notes: Optional[str] = None
    subtotal: Optional[float] = None
    taxes: Optional[float] = None
    shippingCosts: Optional[float] = None
    total: Optional[float] = None
    currency: Optional[Currency] = None
    paymentTerms: Optional[str] = None
    attachments: Optional[List[Attachments]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Payments(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    amount: Optional[float] = None
    date: Optional[datetime] = None
    currency: Optional[Currency] = None
    status: Optional[PaymentStatus] = None
    orderId: Optional[str] = None
    journalId: Optional[str] = None
    tip: Optional[float] = None
    transactionId: Optional[str] = None
    notes: Optional[str] = None
    description: Optional[str] = None
    createdAt: Optional[datetime] = None
    invoice: Optional[Invoices] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    paymentMethod: Optional[PaymentMethods] = None
    customer: Optional[Customers] = None
    receiptEmail: Optional[str] = None
    metadata: Optional[Metadata] = None
    shippingDetails: Optional[ShippingDetails] = None
    billingDetails: Optional[BillingDetails] = None
    paymentIntent: Optional[str] = None
    paymentCaptureMethod: Optional[str] = None
    refund: Optional[Refunds] = None
    paymentProcessor: Optional[str] = None
    webhookUrl: Optional[str] = None
    cardDetails: Optional[CardDetails] = None
    modifyToken: Optional[str] = None


class Expenses(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    accountId: Optional[str] = None
    transactionId: Optional[str] = None
    amount: Optional[float] = None
    currencyCode: Optional[str] = None
    dateIncurred: Optional[datetime] = None
    description: Optional[str] = None
    category: Optional[ExpenseCategories] = None
    merchant: Optional[str] = None
    receiptUrls: Optional[List[str]] = None
    paymentMethod: Optional[PaymentMethods] = None
    status: Optional[ExpenseApprovalStatus] = None
    tax: Optional[List[Taxes]] = None
    note: Optional[str] = None
    lineItems: Optional[List[Items]] = None
    attachments: Optional[List[Attachments]] = None
    reportId: Optional[str] = None
    createdByUserId: Optional[str] = None
    approvedByUserId: Optional[str] = None
    customFields: Optional[List[CustomAttributes]] = None
    tags: Optional[List[str]] = None
    location: Optional[Addresses] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class Transactions(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    accountId: Optional[str] = None
    accountCode: Optional[str] = None
    accountName: Optional[str] = None
    invoiceId: Optional[str] = None
    orderId: Optional[str] = None
    contact: Optional[Contacts] = None
    paymentMethod: Optional[PaymentMethods] = None
    amount: Optional[float] = None
    debitAmount: Optional[float] = None
    creditAmount: Optional[float] = None
    taxAmount: Optional[float] = None
    type: Optional[FinancialTransactionType] = None
    date: Optional[datetime] = None
    currency: Optional[Currency] = None
    recipient: Optional[Customers] = None
    sender: Optional[Customers] = None
    description: Optional[str] = None
    checkNumber: Optional[str] = None
    transactionCategory: Optional[TransactionType] = None
    items: Optional[List[Items]] = None
    tags: Optional[List[str]] = None
    status: Optional[FinancialTransactionStatus] = None
    transactionMethod: Optional[TransactionMethod] = None
    refund: Optional[Refunds] = None
    dispute: Optional[Disputes] = None
    metadata: Optional[Metadata] = None
    exchangeRate: Optional[float] = None
    shipping: Optional[ShippingDetails] = None
    billingDetails: Optional[BillingDetails] = None
    applicationFee: Optional[float] = None
    paymentIntent: Optional[str] = None
    attachments: Optional[List[Attachments]] = None
    taxExempt: Optional[bool] = None
    foreignCurrency: Optional[CurrencyDetails] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Accounts(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    name: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    accountNumber: Optional[str] = None
    accountCode: Optional[str] = None
    taxType: Optional[str] = None
    allowPayments: Optional[bool] = None
    showInExpenses: Optional[bool] = None
    accountType: Optional[AccountType] = None
    balance: Optional[float] = None
    currency: Optional[Currency] = None
    owner: Optional[Customers] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    closedAt: Optional[datetime] = None
    status: Optional[FinancialAccountStatus] = None
    transactions: Optional[List[Transactions]] = None
    branch: Optional[str] = None
    notes: Optional[str] = None
    interestRate: Optional[float] = None
    overdraftLimit: Optional[float] = None
    overdraftProtection: Optional[bool] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Messages(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    messageType: Optional[str] = None
    medium: Optional[str] = None
    reference: Optional[Entity] = None
    senderId: Optional[str] = None
    senderEmail: Optional[str] = None
    receiverId: Optional[str] = None
    receiverRoles: Optional[List[ReceiverRole]] = None
    recipientEmails: Optional[List[str]] = None
    bcc: Optional[str] = None
    cc: Optional[str] = None
    subject: Optional[str] = None
    content: Optional[str] = None
    timestamp: Optional[datetime] = None
    readStatus: Optional[MessageReadStatus] = None
    attachments: Optional[List[Attachments]] = None
    replyToMessageId: Optional[str] = None
    type: Optional[MessageContentType] = None
    threadId: Optional[str] = None
    chatId: Optional[str] = None
    templateId: Optional[str] = None
    historyId: Optional[str] = None
    tags: Optional[List[KeyValues]] = None
    trackingSettings: Optional[List[KeyValues]] = None
    metadata: Optional[List[Metadata]] = None
    deliveryStatus: Optional[MessageDeliveryStatus] = None
    priority: Optional[PriorityLevel] = None
    reactions: Optional[List[Reactions]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Conversations(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    customFields: Optional[List[CustomAttributes]] = None
    participants: Optional[List[Participants]] = None
    messages: Optional[List[Messages]] = None
    comments: Optional[List[Comments]] = None
    title: Optional[str] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    type: Optional[ChatType] = None
    status: Optional[ConversationStatus] = None
    unreadCount: Optional[float] = None
    isPinned: Optional[bool] = None
    isRead: Optional[bool] = None
    lastMessage: Optional[Messages] = None
    metadata: Optional[str] = None
    lastReadMessageId: Optional[str] = None
    modifyToken: Optional[str] = None


class ResponseFormat(BaseModel):
    commonModel: Optional[str] = None
    type: Optional[ResponseFormatType] = None
    schema_: Optional[JsonSchema] = Field(None, alias='schema')


class AiMessagesContent(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    modifyToken: Optional[str] = None
    text: Optional[str] = None
    name: Optional[str] = None
    image: Optional[Images] = None
    toolUseId: Optional[str] = None
    type: Optional[AiMessagesContentType] = None
    toolResultContent: Optional[List[ToolResultContent]] = None
    isError: Optional[bool] = None


class AiMessages(BaseModel):
    commonModel: Optional[str] = None
    index: Optional[float] = None
    name: Optional[str] = None
    refusal: Optional[str] = None
    role: Optional[AiRole] = None
    content: Optional[List[AiMessagesContent]] = None
    finishReason: Optional[str] = None
    toolCalls: Optional[List[ToolCalls]] = None


class Chats(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    objectType: Optional[str] = None
    createdAt: Optional[datetime] = None
    model: Optional[str] = None
    systemFingerprint: Optional[str] = None
    messages: Optional[List[AiMessages]] = None
    tools: Optional[List[JsonSchema]] = None
    usage: Optional[AiUsage] = None
    responseFormat: Optional[ResponseFormat] = None
    toolChoice: Optional[AiToolChoice] = None
    topP: Optional[float] = None
    topK: Optional[float] = None
    temperature: Optional[float] = None
    maxTokens: Optional[float] = None
    stopSequences: Optional[List[str]] = None
    systemMessage: Optional[str] = None
    seed: Optional[float] = None
    frequencyPenalty: Optional[float] = None
    numberOfCompletions: Optional[float] = None
    presencePenalty: Optional[float] = None
    enableParallelToolCalls: Optional[bool] = None
    userId: Optional[str] = None
    logitBias: Optional[Dict[str, Any]] = None
    modifyToken: Optional[str] = None


class CreditNoteLines(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    description: Optional[str] = None
    quantity: Optional[float] = None
    unitPrice: Optional[float] = None
    total: Optional[float] = None
    taxRate: Optional[float] = None
    product: Optional[Products] = None
    account: Optional[str] = None
    customFields: Optional[List[CustomAttributes]] = None


class CreditNotes(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    number: Optional[str] = None
    amount: Optional[float] = None
    companyId: Optional[str] = None
    companyName: Optional[str] = None
    creditType: Optional[CreditType] = None
    currency: Optional[Currency] = None
    issuedDate: Optional[datetime] = None
    dueDate: Optional[datetime] = None
    status: Optional[CreditNoteStatus] = None
    description: Optional[str] = None
    memo: Optional[str] = None
    adjustment: Optional[float] = None
    reason: Optional[str] = None
    customer: Optional[Customers] = None
    lines: Optional[List[CreditNoteLines]] = None
    billingAddress: Optional[Addresses] = None
    shippingAddress: Optional[Addresses] = None
    taxAmount: Optional[float] = None
    taxRate: Optional[float] = None
    vatName: Optional[str] = None
    vatNumber: Optional[str] = None
    discounts: Optional[List[float]] = None
    payments: Optional[List[Payments]] = None
    attachments: Optional[List[Attachments]] = None
    metadata: Optional[Metadata] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    active: Optional[bool] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Recordings(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    accountId: Optional[str] = None
    hostId: Optional[str] = None
    duration: Optional[float] = None
    callType: Optional[CallDirection] = None
    startTime: Optional[datetime] = None
    endTime: Optional[datetime] = None
    topic: Optional[str] = None
    fileSize: Optional[float] = None
    password: Optional[SecretStr] = None
    files: Optional[List[Attachments]] = None
    name: Optional[str] = None
    description: Optional[str] = None
    participants: Optional[List[Speakers]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None


class EventRecurrences(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    rules: Optional[List[EventRecurrenceRules]] = None


class Events(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    location: Optional[str] = None
    link: Optional[str] = None
    timeZone: Optional[str] = None
    startDate: Optional[datetime] = None
    endDate: Optional[datetime] = None
    organizer: Optional[Users] = None
    attendees: Optional[List[Users]] = None
    status: Optional[EventStatus] = None
    visibility: Optional[EventVisibility] = None
    rules: Optional[EventRules] = None
    entryPoints: Optional[List[EntryPoints]] = None
    reminders: Optional[List[EventReminders]] = None
    recurrence: Optional[EventRecurrences] = None
    attachments: Optional[List[Attachments]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Threads(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    snippet: Optional[str] = None
    lastMessageId: Optional[str] = None
    lastHistoryId: Optional[str] = None
    tags: Optional[List[KeyValues]] = None
    messages: Optional[List[Messages]] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    deleted: Optional[bool] = None
    modifyToken: Optional[str] = None


class Drafts(BaseModel):
    commonModel: Optional[str] = None
    id: Optional[str] = None
    messageId: Optional[str] = None
    reference: Optional[Entity] = None
    senderId: Optional[str] = None
    senderEmail: Optional[str] = None
    receiverId: Optional[str] = None
    recipientEmails: Optional[List[str]] = None
    bcc: Optional[str] = None
    cc: Optional[str] = None
    subject: Optional[str] = None
    content: Optional[str] = None
    timestamp: Optional[datetime] = None
    attachments: Optional[List[Attachments]] = None
    replyToMessageId: Optional[str] = None
    type: Optional[MessageContentType] = None
    threadId: Optional[str] = None
    chatId: Optional[str] = None
    templateId: Optional[str] = None
    tags: Optional[List[KeyValues]] = None
    trackingSettings: Optional[List[KeyValues]] = None
    metadata: Optional[List[Metadata]] = None
    priority: Optional[PriorityLevel] = None
    createdAt: Optional[datetime] = None
    updatedAt: Optional[datetime] = None
    modifyToken: Optional[str] = None
